/*
Copyright (C) Amri-Ksb 2007 All Rights Reserved.

HART DEVICE DESCRIPTION 

Manufacturer:           AMRI-KSB
Device:                 HART Positionner SI
Device Revision:        1
Filename:               KSB_SMARTRONIC.DDL 
Internal Revision:      (18.05.07)

Author: AGILiCOM
Dept:                   
City:                   
Country:                
*/ 

  

#include "macros.h"
#include "methods.h"
MANUFACTURER KSB,
DEVICE_TYPE _SMARTRONIC_MA,
DEVICE_REVISION 2,
DD_REVISION 9

/* In the case of Offline Configuration all upload variables must be of Handling R&W */
/* In normal mode all variables must be of Handling Read */
/* This requires to define write_actions and validities for each writeable variable*/

//FOR 6.1 STANDARD
/*#define IDENTIFY_REPLY2 \
    response_code, device_status, 254, device_type, \
    request_preambles, universal_revision, transmitter_revision, \
    software_revision, hardware_revision <0xf8>, physical_signaling_code <0x07>, \
    device_flags, device_id, response_preambles, max_num_device_variables, \
    config_change_counter, extended_fld_device_status, manufacturer_id   */

//FOR 6.1 STANDARD
//#define KSB_MANUFACTURER_CODE  0x600c 
//#define KSB_MANUFACTURER_NAME  "KSB"
//#define KSB_DEVICE_CODE        0xe08f 
//#define KSB_DEVICE_NAME        "SMARTRONIC MA"
/*********************************************************************************/
/**						UNIVERSAL WRITE COMMANDS DEFINITION       				**/
/*********************************************************************************/
#define WRITE_COMMAND_POLLING_ADDRESS		6   /*  Write polling address   */
#define WRITE_COMMAND_MESSAGE       		17  /*  Write message   */
#define WRITE_COMMAND_TAG_DESC_DATE    		18  /*  Write tag, descriptor, date   */
#define WRITE_COMMAND_FIN_ASSEM_NUM    		19  /*  Write final assembly number   */
#define WRITE_COMMAND_LONG_TAG      		22  /*  Write long tag   */

/*********************************************************************************/
/**						COMMON PRACTICE COMMANDS DEFINITION       				**/
/*********************************************************************************/
#define COMMON_COMMAND_PERFORM_SELF_TEST	41    /*Perform device self test*/

/*********************************************************************************/
/**						SPECIFIC COMMANDS DEFINITION            				**/
/*********************************************************************************/
#define READ_COMMAND_ENDSTOP_POSITION		128    /*Read position of endstop sensor*/
#define READ_COMMAND_POSITIONNER_STATE		129    /*Read positionner state*/
#define READ_COMMAND_CONTROL_MODE   		130    /*Read control mode*/
#define WRITE_COMMAND_CONTROL_MODE   		131    /*Write control mode*/
#define READ_COMMAND_POSITION_SETPOINT 		132    /*Read HART position setpoint*/
#define WRITE_COMMAND_POSITION_SETPOINT 	133    /*Write HART position setpoint*/
#define READ_COMMAND_GAIN            		140    /*Read gain of the position regulator*/
#define WRITE_COMMAND_GAIN            		141    /*Write gain of the position regulator*/
#define READ_COMMAND_DEADBAND         		142    /*Read dead band of the positionner*/
#define WRITE_COMMAND_DEADBAND         		143    /*Write dead band of the positionner*/
#define READ_COMMAND_POSITIONER_INFO   		146    /*Read product configuration*/
#define WRITE_COMMAND_POSITIONER_INFO  		147    /*Write product configuration*/
#define READ_COMMAND_ACTUATOR_INFO     		148    /*Read product tag number*/
#define WRITE_COMMAND_ACTUATOR_INFO		    149    /*Write product tag number*/
#define READ_COMMAND_VALVE_TYPE     		150    /*Read valve type*/
#define WRITE_COMMAND_VALVE_TYPE  		    151    /*Write valve type*/
#define READ_COMMAND_TOTAL_RT        		155    /*Read total run time*/
//#define READ_COMMAND_RST_STAT        		156    /*Read reset statistics*/
#define READ_COMMAND_RT_SINCE_RST      		157    /*Read run time since last statistic reset*/
#define READ_COMMAND_NB_OPERATIONS     		158    /*Read number of operations*/
#define READ_COMMAND_OC_FCT_POINTS          161    /*Read the relation between input current and position of valve*/
#define WRITE_COMMAND_OC_FCT_POINTS         162    /*Write the relation between input current and position of valve*/
#define READ_COMMAND_PROTECT_MODE           163    /*Read the protection mode*/
#define WRITE_COMMAND_PROTECT_MODE          164    /*Write the protection mode*/
#define WRITE_COMMAND_ETALON_INPUT_4mACURRENT  165    /*write gaugement of input current loop*/
#define WRITE_COMMAND_ETALON_INPUT_20mACURRENT  166    /*write gaugement of input current loop*/
#define WRITE_COMMAND_ETALON_OUTPUT_4_20mACURRENT  167    /*write gaugement of outpur current loop*/
#define WRITE_COMMAND_GESTION_ETALON_OUTPUT_CURRENT  168    /*write gestion of gaugement of output current loop*/
#define WRITE_COMMAND_GESTION_AUTOCALIBRATION  169    /*write gestion of gaugement of output current loop*/
#define READ_COMMAND_STATE_OF_CMD_169_AND_170  171    /*write gestion of gaugement of output current loop*/
#define READ_COMMAND_VALUE_ETALON_OUTPUT  172    /*write gestion of gaugement of output current loop*/


 
/****************************************************************************/
/* 				IMPORT: Standard Tables 	(TABL20_4.ddl) 					*/
/****************************************************************************/
IMPORT STANDARD _TABLES, DEVICE_REVISION 20, DD_REVISION 4
{
	EVERYTHING;
    //HART_DEVICE_TABLES;  // Pulls in all the items for typical HART devices.

//FOR 6.1 STANDARD
/*	REDEFINITIONS 
	{
        REDEFINE VARIABLE manufacturer_id
        {
            LABEL "|en|4-1-1 Manufacturer|fr|4-1-1 Fabricant|de|4-1-1 Manufacturer";
            HELP "|en|Device manufacturer|fr|Fabricant du produit|de|Device manufacturer";
            HANDLING READ;
            TYPE ENUMERATED (2)
            {
				{	KSB_MANUFACTURER_CODE,  KSB_MANUFACTURER_NAME 	}
            }
        }
		REDEFINE VARIABLE  device_type
		{
            LABEL "|en|4-1-2 Type|fr|4-1-2 Type|de|4-1-2 Type";
            HELP "|en|Device type|fr|Type de produit|de|Device type";
            HANDLING READ;
			TYPE ENUMERATED (2)
			{
				{	KSB_DEVICE_CODE,  KSB_DEVICE_NAME	}
			}
		} 
    } */    
}  

/****************************************************************************/
/* 				IMPORT: Standard Menus 	(MENU.ddl)							*/
/****************************************************************************/
/*IMPORT STANDARD _MENU, DEVICE_REVISION 1, DD_REVISION 1
{
    EVERYTHING;
}*/

/****************************************************************************/
/* 				IMPORT: Universal Commands 	(UNIV7.DDL)						*/
/****************************************************************************/
IMPORT STANDARD _UNIVERSAL, DEVICE_REVISION 7, DD_REVISION 2
{
    /* Standard functions to be used */
	EVERYTHING;

    /* Redefinitions */
	REDEFINITIONS 
	{


    //FOR 7.2 STANDARD
         /*VARIABLE universal_revision
		{
            REDEFINE LABEL "|en|4-1-9-1 HART univ. rev.|fr|4-1-9-1 HART univ vers|de|4-1-9-1 HART univ. rev.";
            REDEFINE HELP "|en|HART Universal command revision|fr|Version command universel HART|de|HART Universal command revision";
			REDEFINE TYPE UNSIGNED_INTEGER
			{
				MIN_VALUE  7;
			}
		}

        VARIABLE transmitter_revision
        {
            REDEFINE LABEL "|en|4-1-9-2 Device revision|fr|4-1-9-2 Version appareil|de|4-1-9-2 Device revision";
            REDEFINE HELP "|en|Device revision|fr|Version du produit|de|Device revision";
        }

        VARIABLE software_revision
        {
            REDEFINE LABEL "|en|4-1-9-3 Software revision|fr|4-1-9-3 Version logiciel|de|4-1-9-3 Software revision";
            REDEFINE HELP "|en|Device software revision|fr|Version logiciel du produit|de|Device software revision";
        }

        VARIABLE hardware_revision
        {
            REDEFINE LABEL "|en|4-1-9-4 Hardware revision|fr|4-1-9-3 Version matriel|de|4-1-9-4 Hardware revision";
            REDEFINE HELP "|en|Device hardware revision|fr|Version matriel du produit|de|Device hardware revision";
        }

        VARIABLE polling_address
        {
            REDEFINE LABEL "|en|4-5-1 Polling address|fr|4-5-1 Polling address|de|4-5-1 Polling address";
            REDEFINE HELP "|en|HART polling address|fr|Polling address HART|de|HART polling address";
        }

		VARIABLE tag
		{
			REDEFINE LABEL "|en|4-1-3 Tag|fr|4-1-3 Tag|de|4-1-3 Tag";
            REDEFINE HELP "|en|Device tag|fr|Tag produit|de|Device tag";
		}

        VARIABLE descriptor
		{
			REDEFINE LABEL "|en|4-1-4 Descriptor|fr|4-1-4 Description|de|4-1-4 Descriptor";
            REDEFINE HELP "|en|Device descriptor|fr|Description produit|de|Device descriptor";
		}

        VARIABLE longTag
		{
			REDEFINE LABEL "|en|4-1-5 Long tag|fr|4-1-5 Long tag|de|4-1-5 Long tag";
            REDEFINE HELP "|en|Device long tag|fr|Long tag produit|de|Device long tag";
		}

        VARIABLE message
		{
			REDEFINE LABEL "|en|4-1-6 Message|fr|4-1-6 Message|de|4-1-6 Message";
            REDEFINE HELP "|en|Device message|fr|Message produit|de|Device message";
		}

        VARIABLE final_assembly_number
        {
            REDEFINE LABEL "|en|4-1-7 Assembly number|fr|4-1-7 Numro d'assemblage|de|4-1-7 Assembly number";
            REDEFINE HELP "|en|Device assembly number|fr|Numro d'assemblage du produit|de|Device assembly number";
            REDEFINE HANDLING   READ;
        }

        VARIABLE date
        {
            REDEFINE LABEL "|en|4-1-8-1 Date|fr|4-1-8-1 Date|de|4-1-8-1 Date";
            REDEFINE HELP "|en|Device assembly date|fr|Date d'assemblage du produit|de|Device assembly date";
        }  */

        //The transactions will need to be redefined to use the
        //16-bit Manufacturer and Device Type codes 
        //(Command 0)
        /*COMMAND read_unique_identifier
        {
            REDEFINE TRANSACTION
            {
                REQUEST {}
                REPLY
                {
                    IDENTIFY_REPLY2
                }
            }
        }
        COMMAND read_unique_identifier_with_tag
        {
            REDEFINE TRANSACTION
            {
                REQUEST
                {
                    tag
                }
                REPLY
                {
                    IDENTIFY_REPLY2
                }
            }
        }

        COMMAND read_unique_identifier_with_long_tag
        {
            REDEFINE TRANSACTION
            {
                REQUEST
                {
                    longTag
                }
                REPLY
                {
                    response_code, device_status,
//                    IDENTIFY_REPLY2
                    longTag
                }
            }
        } */

        /*****************************************************************************
         * NOTE - Command 9 is used to access the units code for PV.
         * 
         * However, all field devices are still required to return the correct units 
         * for this command.
         * (Command 3) 
         */
        COMMAND read_dynamic_variables_and_pv_current 
        {
            REDEFINE TRANSACTION
            {
                REQUEST 
                {
                }
                REPLY
                {
                    response_code, device_status,
                    PV.DAQ.ANALOG_VALUE,
                    pv_position_variable.DIGITAL_UNITS,
                    pv_position_variable.DIGITAL_VALUE,
                    sv_setpoint_position.DIGITAL_UNITS,
                    sv_setpoint_position.DIGITAL_VALUE,
                    tv_system_deviation.DIGITAL_UNITS,
                    tv_system_deviation.DIGITAL_VALUE,
                    qv_copy_position.DIGITAL_UNITS,
                    qv_copy_position.DIGITAL_VALUE
                }
            }
        }


        /* The transaction will need to be redefine to show the correct
           number of device variables returned in this command 
           (Command 9) */
        COMMAND read_device_variables_and_status 
        {
            REDEFINE TRANSACTION 
            {
                REQUEST
                {
                    0, 1, 2, 3
                }
                REPLY
                {
                    response_code, device_status,
                    extended_fld_device_status,
                    0,                          // device variable code 0
                    pv_position_variable.CLASSIFICATION,
                    pv_position_variable.DIGITAL_UNITS,
                    pv_position_variable.DIGITAL_VALUE,
                    pv_position_variable.DATA_QUALITY <0xC0>,   // process data status
                    pv_position_variable.LIMIT_STATUS <0x30>,
                    pv_position_variable.DEVICE_FAMILY_STATUS <0x0F>,

                    1,                          // device variable code 1
                    sv_setpoint_position.CLASSIFICATION,
                    sv_setpoint_position.DIGITAL_UNITS,
                    sv_setpoint_position.DIGITAL_VALUE,
                    sv_setpoint_position.DATA_QUALITY <0xC0>,   // process data status
                    sv_setpoint_position.LIMIT_STATUS <0x30>,
                    sv_setpoint_position.DEVICE_FAMILY_STATUS <0x0F>,

                    2,                         // device variable code 2
                    tv_system_deviation.CLASSIFICATION,
                    tv_system_deviation.DIGITAL_UNITS,
                    tv_system_deviation.DIGITAL_VALUE,
                    tv_system_deviation.DATA_QUALITY <0xC0>,    // process data status
                    tv_system_deviation.LIMIT_STATUS <0x30>,
                    tv_system_deviation.DEVICE_FAMILY_STATUS <0x0F>,

                    3,                          // device variable code 3
                    qv_copy_position.CLASSIFICATION,
                    qv_copy_position.DIGITAL_UNITS,
                    qv_copy_position.DIGITAL_VALUE,
                    qv_copy_position.DATA_QUALITY <0xC0>,   // process data status
                    qv_copy_position.LIMIT_STATUS <0x30>,
                    qv_copy_position.DEVICE_FAMILY_STATUS <0x0F>
                }
            }
           
         }
 	}
}

/****************************************************************************/
/* 				IMPORT: Practice Commands (COMMON9.DDL)        				*/
/****************************************************************************/
IMPORT STANDARD _COMMON_PRACTICE, DEVICE_REVISION 9, DD_REVISION 2
{
    COMMAND perform_self_test;              // command 41
    //COMMAND read_additional_device_status;  // command 48

    //VARIABLE device_specific_status_0;
    //VARIABLE device_specific_status_1;
    //VARIABLE device_specific_status_2;
    //VARIABLE device_specific_status_3;
    //VARIABLE device_specific_status_4;
    //VARIABLE device_specific_status_5;
    //VARIABLE analog_channel_saturated1;
    //VARIABLE analog_channel_saturated2;
    //VARIABLE analog_channel_saturated3;
    //VARIABLE analog_channel_fixed1;
    //VARIABLE analog_channel_fixed2;
    //VARIABLE analog_channel_fixed3;
    //VARIABLE device_specific_status_14;
    //VARIABLE device_specific_status_15;
    //VARIABLE device_specific_status_16;
    //VARIABLE device_specific_status_17;
    //VARIABLE device_specific_status_18;
    //VARIABLE device_specific_status_19;
    //VARIABLE device_specific_status_20;
    //VARIABLE device_specific_status_21;
    //VARIABLE device_specific_status_22;
    //VARIABLE device_specific_status_23;
    //VARIABLE device_specific_status_24;
}

/****************************************************************************/
/* 				IMPORT: PV standard 	        						*/
/****************************************************************************/
IMPORT STANDARD _PV, DEVICE_REVISION 1, DD_REVISION 1
{
    EVERYTHING;

    
    REDEFINITIONS
    { 
        REDEFINE VARIABLE loopCurrent
        {
            LABEL "|en|1-1-1 Input current|fr|1-1-1 Courant d'entre";
            HELP "|en|Input current|fr|Courant d'entre";
            CLASS ANALOG_CHANNEL & DYNAMIC;
            HANDLING READ;
            CONSTANT_UNIT [mA];
            TYPE FLOAT
            {
 		        DISPLAY_FORMAT 	 "5.2f";
                EDIT_FORMAT "8.2f";

        	}
        }  

        /*REDEFINE COLLECTION OF VARIABLE analog_io
        {
            LABEL "|en|1-1-1 Input current|fr|1-1-1 Courant d'entre";
            HELP [analog_input_block_help];
            MEMBERS
            {
                // * Analog Information * //
                ANALOG_VALUE,           loopCurrent,        "|en|1-1-1 Input current|fr|1-1-1 Courant d'entre",         "|en|Input current|fr|Courant d'entre";
                ALARM_CODE,             loop_alarm_code,    [alarm_type],           [alarm_code_help];
                ANALOG_CHANNEL_FLAGS,   loop_flags,         [analog_channel_flags], [analog_channel_flags_help];
            }
        }*/

        REDEFINE ARRAY OF COLLECTION dynamic_variables
        {
            ELEMENTS
            {
                PRIMARY,        primary_variable,       ""; 
                SECONDARY,      secondary_variable,     [sv];
                TERTIARY,       tertiary_variable,      [tv];
                QUATERNARY,     quaternary_variable,    [qv];
            }
        }  

        /* 
         * Most devices use the same data item for range units (command 15) and the sensor units.
         * when this is true the following should be added.  if your device uses a different variable
         * for range units you should reference it here 
         */
        COLLECTION OF VARIABLE scaling
        {
            MEMBERS
            {
                ADD RANGE_UNITS, pv_position_variable.DIGITAL_UNITS, [range_units], [range_units_help];
            } 
        }
    }
}

/*******************************************************************************/
/**				    Mandatory Dynamic Variables Configuration							  **/
/*******************************************************************************/

/******************************************************/
/******** deviceVariables1 : position ******************/
/******************************************************/
VARIABLE  position_value 
{
	LABEL 	"|en|1-1-2 Position value (PV)|fr|1-1-2 Position (PV)|de|1-1-2 Position value (PV)";
	HELP    "|en|Position of the valve|fr|Position du robinet|de|Position of the valve";
// 	CLASS  	DYNAMIC & CORRECTION;
 	CLASS  	DYNAMIC;
	TYPE   	FLOAT
	{
        MIN_VALUE 		-50.0;
 		MAX_VALUE 		150.0;
  		DISPLAY_FORMAT 	 "5.1f";
 	}
	CONSTANT_UNIT   "%";
	HANDLING        READ;
}

VARIABLE  position_unit
{
	LABEL	"Position unit";
	HELP    [digital_units_help];
 	CLASS   CORRECTION;
	TYPE    ENUMERATED 
	{
 		{	57,  	"%"	}
	}
	HANDLING   READ; 
} 

VARIABLE positionPDQ
{
    LABEL "Position PDQ";
    HELP [process_data_quality_help];
    CLASS CORRECTION & DYNAMIC;
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        PROCESS_DATA_STATUS_CODES         
    }
}

VARIABLE positionLS
{
    LABEL "Limit Status";
    HELP [limit_status_help];
    CLASS CORRECTION & DYNAMIC;
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        LIMIT_STATUS_CODES
    }
}

VARIABLE positionStatus
{
    LABEL "Position Fmly stat";
    HELP [family_status_help];
    CLASS CORRECTION & DYNAMIC;
    HANDLING READ;
    TYPE BIT_ENUMERATED
    {
        { 0x08, device_family_status(0x08), MORE }
    } 
}

VARIABLE positionClassification
{
    LABEL "Position Class";
    HELP [classification_help];
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        ALL_CLASSIFICATIONS
    }
}

VARIABLE positionFamily
{
    LABEL "Position Dev fmly";
    HELP [device_family_help];
    CLASS DEVICE;
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        ALL_FAMILIES
    }
}

VARIABLE positionUSL
{
    LABEL "Upper transducer limit";
    HELP "";
    HANDLING READ;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".3f";
    }
}

VARIABLE positionLSL
{
    LABEL "Lower transducer limit";
    HELP "";
    HANDLING READ;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".3f";
    }
}

VARIABLE positionMinimumSpan
{
    LABEL "Minimum span";
    HELP "";
    HANDLING READ;
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".3f";
    }
}

VARIABLE positionSerialNumber
{
    LABEL "Positionner serial number";
    HELP "";
    CLASS DEVICE;
    HANDLING READ;
    TYPE UNSIGNED_INTEGER (3)
    {
        DISPLAY_FORMAT  "7d";
    }
}

VARIABLE positionDampingValue
{
    LABEL " damping value";
    HELP  "";
    /* You will probably add a write command for this later
       usualy command 34 for Write Primary Variable Damping Value */
    HANDLING READ;
    CONSTANT_UNIT [sec];
    TYPE FLOAT
    {
        DISPLAY_FORMAT ".3f";
    }
}
/*--------------------------------------------------------------------------*/
/******************************************************/
/******** definition of mandatory collections *********/
/******************************************************/

COLLECTION OF VARIABLE pv_position_variable
{
//    LABEL "Position";
    LABEL "";
    HELP "";
    MEMBERS
    {   
        DIGITAL_VALUE,              position_value,              "|en|1-1-2 Position value (PV)|fr|1-1-2 Position (PV)|de|1-1-2 Position value (PV)",                "|en|Position of the valve|fr|Position du robinet|de|Position of the valve";
        DIGITAL_UNITS,              position_unit,              [units],                [digital_units_help];
        DATA_QUALITY,               positionPDQ,                [process_data_quality], [process_data_quality_help];
        LIMIT_STATUS,               positionLS,                 [limit_status],         [limit_status_help];
        DEVICE_FAMILY_STATUS,       positionStatus,             [family_status],        [family_status_help];

        CLASSIFICATION,             positionClassification,     [classification],       [classification_help];
        DEVICE_FAMILY,              positionFamily,             [device_family],        [device_family_help];

        UPPER_SENSOR_LIMIT,         positionUSL,                [usl],                  [upper_sensor_limit_help];
        LOWER_SENSOR_LIMIT,         positionLSL,                [lsl],                  [lower_sensor_limit_help];
        MINIMUM_SPAN,               positionMinimumSpan,        [minimum_span],         [minimum_span_help];
        DAMPING_VALUE,              positionDampingValue,       [damping_value],        [seconds_damping_value_help];

        /* Device Information */
        SENSOR_SERIAL_NUMBER,       positionSerialNumber,       [sensor_serial_number], [sensor_serial_number_help];
    }
}

/*-------------------------------------------------------------------------*/
/******************************************************/
/******** deviceVariables2 : setpoint ******************/
/******************************************************/
VARIABLE  setpoint_value
{
	LABEL	"|en|1-1-3 Setpoint (SV)|fr|1-1-3 Consigne (SV)|de|1-1-3 Setpoint (SV)"; 
	HELP 	"|en|Setpoint position of the valve|fr|Consigne de position du robinet|de|Setpoint position of the valve";
// 	CLASS  	DYNAMIC & CORRECTION;
    CLASS  	DYNAMIC;
	TYPE	FLOAT
	{
        MIN_VALUE 		0.0;
 		MAX_VALUE 		100.0;
 		DISPLAY_FORMAT   "5.1f";
 	}
	CONSTANT_UNIT   "%";
	HANDLING        READ; 
}

VARIABLE  setpoint_unit 
{
	LABEL	"setpoint unit";
	HELP    [digital_units_help];
 	CLASS   CORRECTION;
	TYPE    ENUMERATED 
	{
 		{	57,  	"%"	}
	}
	HANDLING   READ; 
} 

VARIABLE setpointPDQ
{
    LABEL "setpoint PDQ";
    HELP [process_data_quality_help];
    CLASS CORRECTION & DYNAMIC;
    HANDLING READ;
    TYPE ENUMERATED
    {
        PROCESS_DATA_STATUS_CODES
    }
}

VARIABLE setpointLS
{
    LABEL "Limit Status";
    HELP [limit_status_help];
    CLASS CORRECTION & DYNAMIC;
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        LIMIT_STATUS_CODES
    }
}

VARIABLE setpointStatus
{
    LABEL "setpoint Fmly stat";
    HELP [family_status_help];
    CLASS CORRECTION & DYNAMIC;
    HANDLING READ;
    TYPE BIT_ENUMERATED
    {
        { 0x08, device_family_status(0x08), MORE }
    } 
}

VARIABLE setpointClassification
{
    LABEL "setpoint Class";
    HELP [classification_help];
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        ALL_CLASSIFICATIONS
    }
}

VARIABLE setpointFamily
{
    LABEL "setpoint Dev fmly";
    HELP [device_family_help];
    CLASS DEVICE;
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        ALL_FAMILIES
    }
}

/*--------------------------------------------------------------------------*/
/******************************************************/
/******** definition of mandatory collections *********/
/******************************************************/
COLLECTION OF VARIABLE sv_setpoint_position
{
//    LABEL "Setpoint";
    LABEL "";
    HELP "";
	MEMBERS
	{
        DIGITAL_VALUE,              setpoint_value,              "|en|1-1-3 Setpoint (SV)|fr|1-1-3 Consigne (SV)|de|1-1-3 Setpoint (SV)",                    "|en|Setpoint position of the valve|fr|Consigne de position du robinet|de|Setpoint position of the valve";
        DIGITAL_UNITS,              setpoint_unit,              [units],                [digital_units_help];
        DATA_QUALITY,               setpointPDQ,                [process_data_quality], [process_data_quality_help];
        LIMIT_STATUS,               setpointLS,                 [limit_status],         [limit_status_help];
        DEVICE_FAMILY_STATUS,       setpointStatus,             [family_status],        [family_status_help];

        CLASSIFICATION,             setpointClassification,     [classification],       [classification_help];
        DEVICE_FAMILY,              setpointFamily,             [device_family],        [device_family_help];
	}
}


/*-------------------------------------------------------------------------*/

/******************************************************/
/******** deviceVariables3 : deviation ******************/
/******************************************************/
VARIABLE  deviation_value
{
	LABEL	"|en|1-1-4 Deviation (TV)|fr|1-1-4 Erreur (TV)|de|1-1-4 Deviation (TV)";
	HELP  	"|en|Difference between setpoint and position|fr|Diffrence entre consigne et position|de|Difference between setpoint and position";
//	CLASS	DYNAMIC & CORRECTION;
	CLASS	DYNAMIC;
	TYPE 	FLOAT
	{
        MIN_VALUE 		-110.0;
 		MAX_VALUE 		110.0;
 		DISPLAY_FORMAT 	 "5.1f";
	}
	CONSTANT_UNIT   "%";
	HANDLING        READ;
}

VARIABLE  deviation_unit 
{
	LABEL	"System deviation unit";
	HELP    [digital_units_help];
 	CLASS   CORRECTION;
	TYPE    ENUMERATED 
	{
 		{	57,  "%"	}
	}
	HANDLING   READ; 
}

VARIABLE deviationPDQ
{
    LABEL "Deviation PDQ";
    HELP [process_data_quality_help];
    CLASS CORRECTION & DYNAMIC;
    HANDLING READ;
    TYPE ENUMERATED
    {
        PROCESS_DATA_STATUS_CODES
    }
}

VARIABLE deviationLS
{
    LABEL "Limit Status";
    HELP [limit_status_help];
    CLASS CORRECTION & DYNAMIC;
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        LIMIT_STATUS_CODES
    }
}

VARIABLE deviationStatus
{
    LABEL "Deviation Fmly stat";
    HELP [family_status_help];
    CLASS CORRECTION & DYNAMIC;
    HANDLING READ;
    TYPE BIT_ENUMERATED
    {
        { 0x08, device_family_status(0x08), MORE }
    } 
}

VARIABLE deviationClassification
{
    LABEL "Deviation Class";
    HELP [classification_help];
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        ALL_CLASSIFICATIONS
    }
}

VARIABLE deviationFamily
{
    LABEL "Deviation Dev fmly";
    HELP [device_family_help];
    CLASS DEVICE;
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        ALL_FAMILIES
    }
}
/*--------------------------------------------------------------------------*/
/******************************************************/
/******** definition of mandatory collections *********/
/******************************************************/
COLLECTION OF VARIABLE tv_system_deviation
{
//    LABEL "System deviation";
    LABEL "";
    HELP "";
	MEMBERS
	{
        DIGITAL_VALUE,              deviation_value,              "|en|1-1-4 Deviation (TV)|fr|1-1-4 Erreur (TV)|de|1-1-4 Deviation (TV)",                    "|en|Difference between setpoint and position|fr|Diffrence entre consigne et position|de|Difference between setpoint and position";
        DIGITAL_UNITS,              deviation_unit,              [units],                [digital_units_help];
        DATA_QUALITY,               deviationPDQ,                [process_data_quality], [process_data_quality_help];
        LIMIT_STATUS,               deviationLS,                 [limit_status],         [limit_status_help];
        DEVICE_FAMILY_STATUS,       deviationStatus,             [family_status],        [family_status_help];

        CLASSIFICATION,             deviationClassification,     [classification],       [classification_help];
        DEVICE_FAMILY,              deviationFamily,             [device_family],        [device_family_help];
	}
}

/*-------------------------------------------------------------------------*/

/******************************************************/
/******** deviceVariables4 : copy of position *********/
/******************************************************/
VARIABLE  copy_value
{
	LABEL	"|en|1-1-5 Output current (QV)|fr|1-1-5 Courant de recopie (QV)|de|1-1-5 Output current (QV)"; 
	HELP	"|en|Value of the output current (feedback position)|fr|Valeur du courant de recopie (Feedback position)|de|Value of the output current (feedback position)"; 
// 	CLASS  	DYNAMIC & CORRECTION;
 	CLASS  	DYNAMIC;
	TYPE 	FLOAT
	{
        MIN_VALUE 		0.00;
 		MAX_VALUE 		24.00;
 		DISPLAY_FORMAT 	 "5.2f";
	}
	CONSTANT_UNIT   "mA";
	HANDLING        READ;
}

VARIABLE  copy_unit 
{
	LABEL	"Output current unit";
	HELP    [digital_units_help];
 	CLASS   CORRECTION;
	TYPE    ENUMERATED 
	{
 		{	39,  "mA"	}
	}
	HANDLING   READ; 
}

VARIABLE copyPDQ
{
    LABEL "Copy PDQ";
    HELP [process_data_quality_help];
    CLASS CORRECTION & DYNAMIC;
    HANDLING READ;
    TYPE ENUMERATED
    {
        PROCESS_DATA_STATUS_CODES
    }
}

VARIABLE copyLS
{
    LABEL "Limit Status";
    HELP [limit_status_help];
    CLASS CORRECTION & DYNAMIC;
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        LIMIT_STATUS_CODES
    }
}

VARIABLE copyStatus
{
    LABEL "Copy Fmly stat";
    HELP [family_status_help];
    CLASS CORRECTION & DYNAMIC;
    HANDLING READ;
    TYPE BIT_ENUMERATED
    {
        { 0x08, device_family_status(0x08), MORE }
    } 
}

VARIABLE copyClassification
{
    LABEL "Copy Class";
    HELP [classification_help];
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        ALL_CLASSIFICATIONS
    }
}

VARIABLE copyFamily
{
    LABEL "Copy Dev fmly";
    HELP [device_family_help];
    CLASS DEVICE;
    HANDLING READ;
    TYPE ENUMERATED
    {
        /* This is the macro from above macros.h*/
        ALL_FAMILIES
    }
}

/*--------------------------------------------------------------------------*/
/******************************************************/
/******** definition of mandatory collections *********/
/******************************************************/
COLLECTION OF VARIABLE qv_copy_position
{
//    LABEL "Copy of position";
    LABEL "";
    HELP "";
	MEMBERS
	{
        DIGITAL_VALUE,              copy_value,              "|en|1-1-5 Output current (QV)|fr|1-1-5 Courant de recopie (QV)|de|1-1-5 Output current (QV)",                    "|en|Value of the output current (feedback position)|fr|Valeur du courant de recopie (Feedback position)|de|Value of the output current (feedback position)";
        DIGITAL_UNITS,              copy_unit,              [units],                [digital_units_help];
        DATA_QUALITY,               copyPDQ,                [process_data_quality], [process_data_quality_help];
        LIMIT_STATUS,               copyLS,                 [limit_status],         [limit_status_help];
        DEVICE_FAMILY_STATUS,       copyStatus,             [family_status],        [family_status_help];

        CLASSIFICATION,             copyClassification,     [classification],       [classification_help];
        DEVICE_FAMILY,              copyFamily,             [device_family],        [device_family_help];
	}
}  

ARRAY OF COLLECTION deviceVariables
{
    ELEMENTS
    {
        0, pv_position_variable;
        1, sv_setpoint_position;
        2, tv_system_deviation;
        3, qv_copy_position;
    }
}
/*******************************************************************************/
/**				    End of Dynamic Variables Configuration					  **/
/*******************************************************************************/

/*******************************************************************************/
/**				    Manufacturer specific variables definition              **/
/*******************************************************************************/
VARIABLE open_endstop_position
{
	LABEL	"|en|1-2-1 Open endstop|fr|1-2-1 Fin de course ouverture|de|1-2-1 Open endstop";
	HELP	"|en|Open endstop sensor position|fr|Etat detecteur fin de course ouverture|de|Open endstop sensor position";
    CLASS  	DYNAMIC;
	TYPE    UNSIGNED_INTEGER (1)
	{
 		MIN_VALUE 		0;
 		MAX_VALUE 		1;
		DISPLAY_FORMAT 		"1d";
	}
	HANDLING  READ;
} 

VARIABLE close_endstop_position
{
	LABEL	"|en|1-2-2 Closed endstop|fr|1-2-2 Fin de course fermeture|de|1-2-2 Closed endstop";
	HELP	"|en|Closed endstop sensor position|fr|Etat detecteur fin de course fermeture|de|Closed endstop sensor position";
    CLASS  	DYNAMIC;
	TYPE    UNSIGNED_INTEGER (1)
	{
 		MIN_VALUE 		0;
 		MAX_VALUE 		1;
		DISPLAY_FORMAT 		"1d";
	}
    HANDLING  READ;
} 


VARIABLE positioner_state
{
	LABEL	"|en|3-2-2 Positioner status|fr|3-2-2 Etat positionneur|de|3-2-2 Positioner status";
	HELP	"|en|Display the current status of the positioner|fr|Affiche l'tat du positionneur|de|Display the current status of the positioner";
	TYPE    ENUMERATED
	{
        {0, "|en|Run|fr|Marche|de|Run"},
        {1, "|en|Calibration Run|fr|Calibration en cours|de|Calibration Run"},
        {2, "|en|Calibration Done|fr|Calibration effectue|de|Calibration Done"},
        {3, "|en|Calibration Fail|fr|Echec calibration|de|Calibration Fail"},
        {4, "|en|Calibration change rotation direction|fr|La calibration change le sens de fermeture|de|Calibration change rotation direction"},
        {5, "|en|Calibration Start|fr|Mise en marche calibration|de|Calibration Start"},
        {6, "|en|Calibration Pause|fr|Pause|de|Calibration Pause"},
        {7, "|en|Calibration Stop|fr|Calibration arrte|de|Calibration Stop"},
        {8, "|en|Calibration Abord|fr|Calibration annule|de|Calibration Abord"},
        {9, "|en|Calibration Fail:materiel|fr|Echec calibration: Pb matriel|de|Calibration Fail:materiel"},
        {10, "|en|Calibration Fail:regulator|fr|Echec calibration: Pb rgulateur|de|Calibration Fail:regulator"}
	}
	HANDLING  READ;
} 



VARIABLE control_mode
{
	LABEL	"|en|3-1-1 Control mode|fr|3-1-1 Mode Fonctionnement|de|3-1-1 Control mode";
	HELP	"|en|Control mode of the positionner (Auto, Manu, Hart)|fr|Mode de fonctionnement du positionneur (Auto, Manu, Hart)|de|Control mode of the positionner (Auto, Manu, Hart)";
    //CLASS  	DYNAMIC;
	TYPE    ENUMERATED
	{
        {0, "|en|cmd AUTO|fr|Fct AUTO|de|cmd AUTO"},
        {1, "|en|cmd MANU|fr|Fct MANU|de|cmd MANU"},
        {2, "|en|cmd by HART|fr|Fct by HART|de|cmd by HART"}
  //      {3, "|en|CALIB|fr|CALIB"},
  //      {4, "|en|NO CALIB|fr|NON CALIBRE|de|NO CALIB"}
	}
	HANDLING  READ & WRITE;
} 


VARIABLE auto_calib
{
	LABEL	"|en|xxx Auto calib|fr|xxx Autocalibration|de|xxx Auto calib";
	HELP	"|en|Run auto calib (0:not RUN ; 1:RUN)|fr|Lance l'autocalibration|de|Run auto calib (0:not RUN ; 1:RUN)";
	TYPE    ENUMERATED
	{
        {0, "|en|NO|fr|NON|de|"},
        {1, "|en|YES|fr|OUI|de|"}
	}
	HANDLING  READ & WRITE;
} 

VARIABLE HART_position_setpoint
{
	LABEL	"|en|3-1-2 HART setpoint|fr|3-1-2 Consigne HART|de|3-1-2 HART setpoint";
	HELP	"|en|Setpoint position when the positioner is controlled by HART|fr|Consigne lorsque le positionneur est controll en HART|de|Setpoint position when the positioner is controlled by HART";
	TYPE    FLOAT
	{
 		MIN_VALUE 		0.0;
 		MAX_VALUE 		100.0;
		DISPLAY_FORMAT 		"5.1f";
		EDIT_FORMAT 		"5.1f";
	}
    CONSTANT_UNIT   "%";
	HANDLING  READ & WRITE;
} 

VARIABLE position_regulator_opening_gain
{
	LABEL	"|en|3-2-3-1 Opening gain|fr|3-2-3-1 Gain ouverture|de|3-2-3-1 Opening gain";
	HELP	"|en|Gain use for opening operation|fr|Gain utilis pour une action d'ouverture|de|Gain use for opening operation";
	TYPE    FLOAT
	{
 		MIN_VALUE 		0.00;
 		MAX_VALUE 		100.00;
		DISPLAY_FORMAT 		"5.2f";
		EDIT_FORMAT 		"5.2f";
	}
    CONSTANT_UNIT   "%";
	HANDLING  READ & WRITE;
} 

VARIABLE position_regulator_closing_gain
{
	LABEL	"|en|3-2-3-2 Closing gain|fr|3-2-4-2 Gain fermeture|de|3-2-4-2 Closing gain";
	HELP	"|en|Gain use for closing operation|fr|Gain utilis pour une action de fermeture|de|Gain use for closing operation";
	TYPE    FLOAT
	{
 		MIN_VALUE 		0.00;
 		MAX_VALUE 		100.00;
		DISPLAY_FORMAT 		"5.2f";
		EDIT_FORMAT 		"5.2f";
	}
    CONSTANT_UNIT   "%";
	HANDLING  READ & WRITE;
} 

VARIABLE positioner_opening_deadband
{
	LABEL	"|en|3-2-4-1 Opening dead band|fr|3-2-4-1 Bande morte ouverture|de|3-2-4-1 Opening dead band";
	HELP	"|en|Dead band use for opening operation|fr|Bande morte utilis pour une action d'ouverture|de|Dead band use for opening operation";
	TYPE    FLOAT
	{
 		MIN_VALUE 		0.0;
 		MAX_VALUE 		100.0;
		DISPLAY_FORMAT 		"5.1f";
		EDIT_FORMAT 		"5.1f";
	}
    CONSTANT_UNIT   "%";
	HANDLING  READ & WRITE;
} 

VARIABLE positioner_closing_deadband
{
	LABEL	"|en|3-2-4-2 Closing dead band|fr|3-2-4-2 Bande morte fermeture|de|3-2-4-2 Closing dead band";
	HELP	"|en|Dead band use for closing operation|fr|Bande morte utilis pour une action de fermeture|de|Dead band use for closing operation";
	TYPE    FLOAT
	{
 		MIN_VALUE 		0.0;
 		MAX_VALUE 		100.0;
		DISPLAY_FORMAT 		"5.1f";
		EDIT_FORMAT 		"5.1f";
	}
    CONSTANT_UNIT   "%";
	HANDLING  READ & WRITE;
} 

VARIABLE  position_1 
{
	LABEL 	"|en|3-3-2 Setpoint n1|fr|3-2-1 Consigne n1|de|3-3-2 Setpoint n1";
	HELP    "|en|Value of the setpoint n1 associated with input current n1|fr|Valeur de consigne n1 associe au courant d'entre n1|de|Value of the setpoint n1 associated with input current n1";
	TYPE   	FLOAT
	{
        MIN_VALUE 		0.0;
 		MAX_VALUE 		100.0;
  		DISPLAY_FORMAT 	 "5.1f";
 	}
	CONSTANT_UNIT   "%";
	HANDLING    READ & WRITE;
}

VARIABLE  current_1
{
	LABEL	"|en|3-3-1 Current n1|fr|3-2-1 Courant n1|de|3-3-1 Current n1"; 
	HELP    "|en|Value of the input current n1 associated with setpoint n1|fr|Valeur de courant d'entre n1 associe  la consigne n1|de|Value of the input current n1 associated with setpoint n1"; 
	TYPE 	FLOAT
	{
        MIN_VALUE 		0.00;
 		MAX_VALUE 		20.00;
 		DISPLAY_FORMAT 	 "5.2f";
	}
	CONSTANT_UNIT   "mA";
    	HANDLING    READ & WRITE;
}


VARIABLE  position_2 
{
	LABEL 	"|en|3-3-4 Setpoint n2|fr|3-3-4 Consigne n2|de|3-3-4 Setpoint n2";
	HELP    "|en|Value of the setpoint n2 associated with input current n2|fr|Valeur de consigne n2 associe au courant d'entre n2|de|Value of the setpoint n2 associated with input current n2";
	TYPE   	FLOAT
	{
        MIN_VALUE 		0.0;
 		MAX_VALUE 		100.0;
  		DISPLAY_FORMAT 	 "5.1f";
 	}
	CONSTANT_UNIT   "%";
	HANDLING    READ & WRITE;
}

VARIABLE  current_2
{
	LABEL	"|en|3-3-3 Current n2|fr|3-2-3 Courant n2|de|3-3-3 Current n2"; 
	HELP	"|en|Value of the input current n2 associated with setpoint n2|fr|Valeur de courant d'entre n2 associe  la consigne n2|de|Value of the input current n2 associated with setpoint n2"; 
	TYPE 	FLOAT
	{
        MIN_VALUE 		0.00;
 		MAX_VALUE 		20.00;
 		DISPLAY_FORMAT 	 "5.2f";
	}
	CONSTANT_UNIT   "mA";
	HANDLING    READ & WRITE;
}

VARIABLE Eex_Ia
{
	LABEL	"|en|4-2-1 Eex-Ia|fr|4-2-1 Eex-Ia|de|4-2-1 Eex-Ia";
	HELP	"|en|Eex-Ia|fr|Eex-Ia|de|Eex_Ia";
 	TYPE    ENUMERATED
	{
        {0, "|en|Undefined|fr|Non dfinie|de|Undefined"},
        {1, "|en|No|fr|Non|de|Nein"},
        {2, "|en|Yes|fr|Oui|de|Ja"}
	}
//	HANDLING  READ & WRITE;   // for KSB DD
    HANDLING  READ;
}

VARIABLE safety_position
{
	LABEL	"|en|3-5-1 Safety position|fr|3-5-1 Position de scurit|de|3-5-1 Safety position";
	HELP	"|en|Positioner safety position of no power supply. CAUTION : must correspond to the hardware configuration of the positioner|fr|Position de replie hors alimentation lectrique. ATTENTION: doit correspondre  la configuration matriel du positionneur|de|Positioner safety position of no power supply. CAUTION : must correspond to the hardware configuration of the positioner";
	TYPE    ENUMERATED
	{
        {0, "|en|Undefined|fr|Non dfinie|de|Undefined"},
        {1, "|en|None|fr|Sans|de|None"},
        {2, "|en|Closing|fr|Fermeture|de|Closing"},
        {3, "|en|Opening|fr|Ouverture|de|Opening"}
	}
	HANDLING  READ & WRITE;
}

VARIABLE analog_feedback
{
	LABEL	"|en|4-2-2 Analog feedback|fr|4-2-2 Recopie courant|de|4-2-2 Analog feedback";
	HELP	"|en|Positioner analog feedback|fr|Recopie courant du positionneur|de|Positioner analog feedback";
	TYPE    ENUMERATED
	{
        {0, "|en|Undefined|fr|Non dfinie|de|Undefined"},
        {1, "|en|No|fr|Non|de|Nein"},
        {2, "|en|Yes|fr|Oui|de|Ja"}
	}
	HANDLING  READ & WRITE;
}

VARIABLE end_stops
{
	LABEL	"|en|4-2-3 Endstop sensors|fr|4-2-3 Dtecteur fin de course|de|4-2-3 Endstop sensors";
	HELP	"|en|Endstop sensors|fr|Dtecteur fin de course|de|Endstop sensors";
	TYPE    ENUMERATED
	{
        {0, "|en|Undefined|fr|Non dfinie|de|Undefined"},
        {1, "|en|Mechanical switchs|fr|Contact mcanique|de|Mechanical switchs"},
        {2, "|en|Inductive sensors|fr|Dtecteur inductif|de|Inductive sensors"},
        {3, "|en|Inductive Eex-Ia sensors|fr|Dtectieur inductif Eex-Ia|de|Inductive Eex-Ia sensors"}
	}
//	HANDLING  READ & WRITE;     // for KSB DD
   	HANDLING  READ;
}

COLLECTION OF VARIABLE positioner_information
{
    MEMBERS
    {
        EEX_IA, Eex_Ia;
        SAFETY_POSITION, safety_position;
        ANALOG_FEEDBACK, analog_feedback;
        END_STOPS, end_stops;
    }
}

VARIABLE actuator_info_vendor
{
    LABEL "|en|4-3-1 Vendor|fr|4-3-1 Fabricant|de|4-3-1 Vendor";
    HELP "|en|Actuator vendor|fr|Fabricant actionneur|de|Actuator vendorActuator vendor";
    TYPE ASCII (15);
}

VARIABLE actuator_info_type
{
	LABEL	"|en|4-3-2 Type|fr|4-3-2 Type|de|4-3-2 Type";
	HELP	"|en|Actuator type|fr|Type d'actionneur|de|Actuator type";
	TYPE    ENUMERATED
	{
        {0, "|en|Undefined|fr|Non dfinie|de|Undefined"},
        {1, "|en|Single effect|fr|Simple effet|de|Single effect"},
        {2, "|en|Double effect|fr|Double effet|de|Double effect"},
        {3, "|en|Dynactair|fr|Dynactair|de|Dynactair"},
        {4, "|en|Actair|fr|Actair|de|Actair"}
	}
	HANDLING  READ & WRITE;
}

VARIABLE actuator_info_safety_position
{
	LABEL	"|en|4-3-3 Safety position|fr|4-3-3 Position de scurit|de|4-3-3 Safety position";
	HELP	"|en|Actuator safety position|fr|Position de scurit de l'actionneur|de|Actuator safety position";
	TYPE    ENUMERATED
	{
        {0, "|en|Undefined|fr|Non dfinie|de|Undefined"},
        {1, "|en|None (double effect)|fr|Sans (Double effect)|de|None (double effect)"},
        {2, "|en|Closing (single effect)|fr|Fermeture (Simple effet)|de|Closing (single effect)"},
        {3, "|en|Opening (single effect)|fr|Ouverture (Simple effet)|de|Opening (single effect)"}
	}
	HANDLING  READ & WRITE;
}

VARIABLE actuator_info_safety_position_undefinied
{
	LABEL	"|en|4-3-3 Safety position|fr|4-3-3 Position de scurit|de|4-3-3 Safety position";
	HELP	"|en|Actuator safety position|fr|Position de scurit de l'actionneur|de|Actuator safety position";
	TYPE    ENUMERATED
	{
        {0, "|en|Undefined|fr|Non dfinie|de|"}        
	}
	HANDLING  READ & WRITE;
}

VARIABLE actuator_info_safety_position_none
{
	LABEL	"|en|4-3-3 Safety position|fr|4-3-3 Position de scurit|de|4-3-3 Safety position";
	HELP	"|en|Actuator safety position|fr|Position de scurit de l'actionneur|de|Actuator safety position";
	TYPE    ENUMERATED
	{
        {1, "|en|None (double effect)|fr|Sans (Double effect)|de|None (double effect)"}        
	}
	HANDLING  READ & WRITE; 
}

VARIABLE actuator_info_safety_position_other
{
	LABEL	"|en|4-3-3 Safety position|fr|4-3-3 Position de scurit|de|4-3-3 Safety position";
	HELP	"|en|Actuator safety position|fr|Position de scurit de l'actionneur|de|Actuator safety position";
	TYPE    ENUMERATED
	{
        {2, "|en|Closing (single effect)|fr|Fermeture (Simple effet)|de|Closing (single effect)"},
        {3, "|en|Opening (single effect)|fr|Ouverture (Simple effet)|de|Opening (single effect)"}        
	}
	HANDLING  READ & WRITE;
}  

VARIABLE actuator_info_size
{
	LABEL	"|en|4-3-4 Size|fr|4-3-4 Taille|de|4-3-4 Size";
	HELP	"|en|Actuator size|fr|Taille actionneur|de|Actuator size";
	TYPE    UNSIGNED_INTEGER (2)
	{
 		MIN_VALUE 		0;
 		MAX_VALUE 		9999;
		DISPLAY_FORMAT 		"4d";
		EDIT_FORMAT 		"4d";
	}
	HANDLING  READ & WRITE;
}

COLLECTION OF VARIABLE actuator_information
{
    MEMBERS
    {
        VENDOR, actuator_info_vendor;
        TYP, actuator_info_type;
        SAFETY_POSITION, actuator_info_safety_position;
        SIZE, actuator_info_size;
    }
}

VARIABLE valve_info_vendor
{
    LABEL "|en|4-4-1 Vendor|fr|4-4-1 Fabricant|de|4-4-1 Vendor";
    HELP "|en|Valve vendor|fr|Fabricant du robinet|de|Valve vendor";
    TYPE ASCII (15);
}

VARIABLE valve_info_type
{
	LABEL	"|en|4-4-2 Type|fr|4-4-2 Type|de|4-4-2 Type";
	HELP	"|en|Valve type|fr|Type de robinet|de|Valve type";
	TYPE ASCII (15);
}

VARIABLE valve_info_size
{
	LABEL	"|en|4-4-3 Size|fr|4-4-3 Taille|de|4-4-3 Size";
	HELP	"|en|Valve size|fr|Taille du robinet|de|Valve size";
	TYPE    UNSIGNED_INTEGER (2)
	{
 		MIN_VALUE 		0;
 		MAX_VALUE 		9999;
		DISPLAY_FORMAT 		"4d";
		EDIT_FORMAT 		"4d";
	}
	HANDLING  READ & WRITE;
}
VARIABLE closing_direction
{
	LABEL	"|en|3-4-1 Closing direction|fr|3-4-1 Sens fermeture|de|3-4-1 Closing direction";
	HELP "|en|Define if the valve is clockwise or counter clockwise closed|fr|Dfinie si le robinet se ferme dans le sens horaire ou anti horaire|de|Define if the valve is clockwise or counter clockwise closed";
	TYPE    ENUMERATED
	{
        {0, "|en|Clockwise|fr|Horaire|de|Clockwise"},
        {1, "|en|Counter-clockwise|fr|Anti horaire|de|Counter-clockwise"}
	}
	HANDLING  READ & WRITE;
}

COLLECTION OF VARIABLE valve_type
{
    MEMBERS
    {
        VENDOR, valve_info_vendor;
        TYPE_, valve_info_type;
        SIZE, valve_info_size;
        CLOSE_DIR, closing_direction;
    }
}

VARIABLE run_time_days
{
    LABEL "|en|2-2-1-1 Days|fr|2-2-1-1 Jours|de|2-2-1-1 Days";
    HELP "|en|Number of days since the commissioning of the product|fr|Nombre de jours depuis la mise en route du produit|de|Number of days since the commissioning of the product";
    CLASS DIAGNOSTIC;
	TYPE    UNSIGNED_INTEGER (2)
	{
 		MIN_VALUE 		0;
 		MAX_VALUE 		20000;
	}
	CONSTANT_UNIT   "d";
	HANDLING  READ;
}

VARIABLE run_time_hours
{
    LABEL "|en|2-2-1-2 Hours|fr|2-2-1-2 Heures|de|2-2-1-2 Hours";
    HELP "|en|Number of hours since the commissioning of the product|fr|Nombre d'heures depuis la mise en route du produit|de|Number of hours since the commissioning of the product";
    CLASS DIAGNOSTIC;
	TYPE    UNSIGNED_INTEGER (1)
	{
 		MIN_VALUE 		0;
 		MAX_VALUE 		24;
	}
	CONSTANT_UNIT   "h";
	HANDLING  READ;
}

VARIABLE run_time_minutes
{
    LABEL "|en|2-2-1-3 Minutes|fr|2-2-1-3 Minutes|de|2-2-1-3 Minutes";
    HELP "|en|Number of minutes since the commissioning of the product|fr|Nombre de minutes depuis la mise en route du produit|de|Number of minutes since the commissioning of the product";
    CLASS DIAGNOSTIC;
	TYPE    UNSIGNED_INTEGER (1)
	{
 		MIN_VALUE 		0;
 		MAX_VALUE 		60;
	}
	CONSTANT_UNIT   "mn";
	HANDLING  READ;
}

COLLECTION OF VARIABLE run_time
{
    MEMBERS
    {
        DAYS, run_time_days;
        //DAYS, run_time_hours;
        HOURS_, run_time_hours;
        MINUTES_, run_time_minutes;
        //DAYS, run_time_minutes;
    }
}

VARIABLE run_time_since_last_stat_rst_days
{
    LABEL "|en|2-2-2-1 Days|fr|2-2-2-1 Jours|de|2-2-2-1 Days";
    HELP "|en|Number of days since the last statistics reset|fr|Nombre de jours depuis le dernier reset|de|Number of days since the last statistics reset";
    CLASS DIAGNOSTIC;
	TYPE    UNSIGNED_INTEGER (2)
	{
 		MIN_VALUE 		0;
 		MAX_VALUE 		20000;
	}
	CONSTANT_UNIT   "d";
	HANDLING  READ;
}

VARIABLE run_time_since_last_stat_rst_hours
{
    LABEL "|en|2-2-2-2 Hours|fr|2-2-2-2 Heures|de|2-2-2-2 Hours";
    HELP "|en|Number of hours since the last statistics reset|fr|Nombre d'heures depuis le dernier reset|de|Number of hours since the last statistics reset";
    CLASS DIAGNOSTIC;
	TYPE    UNSIGNED_INTEGER (1)
	{
 		MIN_VALUE 		0;
 		MAX_VALUE 		24;
	}
	CONSTANT_UNIT   "h";
	HANDLING  READ;
}

VARIABLE run_time_since_last_stat_rst_minutes
{
    LABEL "|en|2-2-2-3 Minutes|fr|2-2-2-3 Minutes|de|2-2-2-3 Minutes";
    HELP "|en|Number of minutes since the last statistics reset|fr|Nombre de minutes depuis le dernier reset|de|Number of minutes since the last statistics reset";
    CLASS DIAGNOSTIC;
	TYPE    UNSIGNED_INTEGER (1)
	{
 		MIN_VALUE 		0;
 		MAX_VALUE 		60;
	}
	CONSTANT_UNIT   "mn";
	HANDLING  READ;
}

COLLECTION OF VARIABLE run_time_since_last_stat_rst
{
    MEMBERS
    {
        DAYS, run_time_since_last_stat_rst_days;
        //DAYS, run_time_since_last_stat_rst_hours;
        //DAYS, run_time_since_last_stat_rst_minutes;
        HOURS_, run_time_since_last_stat_rst_hours;
        MINUTES_, run_time_since_last_stat_rst_minutes;
    }
}

VARIABLE num_of_operations
{
	LABEL "|en|2-1-1 Number of operations|fr|2-1-1 nombre d'opration|de|2-1-1 Number of operations";
	HELP "|en|Number of operations (one operation corresponds to 180 valve movement)|fr|Nombre d'opration (une opration correspond  un dplacement du robinet de 180|de|Number of operations (one operation corresponds to 180 valve movement)";
    CLASS DIAGNOSTIC;
	TYPE    UNSIGNED_INTEGER (4)
	{
 		MIN_VALUE 		0;
 		MAX_VALUE 		999999999;
	}
	HANDLING  READ;
}


VARIABLE protect_mode
{
	LABEL	"Protect mode";
	HELP	"Protect mode (1:RESTRICTED modification ; 0:UNRESTRICTED modification)";
	TYPE    ENUMERATED
	{    
       {0, "|en|UNRESTRICTED|fr|"},
       {1, "|en|RESTRICTED|fr|"}
	}
	HANDLING  READ;
}

VARIABLE protect_password
{
    LABEL "protect password";
    HELP "protect password";
    TYPE ASCII (4);
}

VARIABLE etalonage
{
	LABEL	"|en|Gaugement|fr|Etalonnage|de|Gaugement";
	HELP	"|en|Write Gaugement state|fr|Ecrire l'etat de l'talonnage|de|Write Gaugement state";
	TYPE    ENUMERATED
	{
        {0, "|en|UNDONE|fr|NON EFFECTUE|de|"},
        {1, "|en|DONE|fr|EFFECTUE|de|"}
	}
	HANDLING  WRITE;
}
VARIABLE etalonage_out_4mA
{
	LABEL	"|en|3-6-2-1 Low level value|fr|3-6-2-1 Valeur niveau bas|de|3-6-2-1 Low level value";
	HELP	"|en|Analog ouput real value for low level calibration|fr|Valeur relle de la sortie analogique pour l'talonnage du niveau bas|de|nalog ouput real value for low level calibration";
	TYPE    FLOAT
	{
 		MIN_VALUE 		0.0;
 		MAX_VALUE 		100.0;
		DISPLAY_FORMAT 		"5.2f";
		EDIT_FORMAT 		"5.2f";
	}
    CONSTANT_UNIT   "mA";
	HANDLING  WRITE;
} 
VARIABLE etalonage_out_20mA
{
	LABEL	"|en|3-6-2-2 High level value|fr|3-6-2-2 Valeur niveau haut|de|3-6-2-2 High level value";
	HELP	"|en|Analog ouput real value for high level calibration|fr|Valeur relle de la sortie analogique pour l'talonnage du niveau haut|de|Analog ouput real value for high level calibration";
	TYPE    FLOAT
	{
 		MIN_VALUE 		0.0;
 		MAX_VALUE 		100.0;
		DISPLAY_FORMAT 		"5.2f";
		EDIT_FORMAT 		"5.2f";
	}
    CONSTANT_UNIT   "mA";
	HANDLING  WRITE;
}
COLLECTION OF VARIABLE etalonage_4_20mA
{
    MEMBERS
    {
        _4mA, etalonage;
        _20mA, etalonage;
    }
}

VARIABLE gestion_etalon_sortie_courant
{
	LABEL	"|en|3-6-2-3 Ana. output Control|fr|3-6-2-3 Controle sortie ana|de|3-6-2-3 Ana. output Control";
	HELP	"|en|Manual control of the analog output for gaugement|fr|Controle manuelle de la sortie analogique pour la calibration|de|Manual control of the analog output for gaugement";
	TYPE    ENUMERATED
	{
        {0, "|en|Auto|fr|Automatique|de|Auto"},
        //{1, "|en|Init gaugement|fr|Init talonnage"},
        {2, "|en|Low level for calibration|fr|Niveau bas pour talonnage|de|Low level for calibration"},
        {3, "|en|High level for calibration|fr|Niveau haut pour talonnage|de|High level for calibration"}
   	}
	HANDLING  WRITE;
} 

VARIABLE gestion_autocalibration
{
	LABEL	"|en|3-2-1 Autocalibration status|fr|3-2-1 Etat autocalibration|de|3-2-1 Autocalibration status";
	HELP	"|en|Status of the Autocalibration.\n\nCAUTION: Communication is lost during autocalibration.\nWhen autocalibration is ended, communication is enable|fr|Pour lancer la procdure d'autocalibration.\n\nAttention :  la communication HART est interrompu pendant l'autocalibration.\nQuand l'autocalibration est fini, la communication est autorise|de|Status of the Autocalibration.\n\nCAUTION: Communication is lost during autocalibration.\nWhen autocalibration is ended, communication is enable";
	TYPE    ENUMERATED
	{
        {0, "|en|End - Standby|fr|Fini - En attente|de|End - Standby"},
        {1, "|en|Run autocalibration|fr|Lancer autocalibration|de|Run autocalibration"},
        {2, "|en|Working...|fr|En cours...|de|Working..."}
    }
	HANDLING  READ;
} 

VARIABLE sauvegarde_cmd151
{
	LABEL	"Save ...";
	HELP	"Use to save valve information";
	TYPE    ENUMERATED
	{
        {0, "|en|Nothing|fr|Rien|de|Nothing"},
        {1, "|en|Save Vendor|fr|Sauvegarde fabricant|de|Save Vendor"},
        {2, "|en|Save Type|fr|Sauvegarde type|de|Save Type"},
        {3, "|en|Save size|fr|Sauvegarde taille|de|Save size"}
   	}
	HANDLING  READ & WRITE;
} 
VARIABLE Lance_autocalib
{
	LABEL	"|en|Autocalibration|fr|Autocalibration|de|Autocalibration";
    TYPE    ENUMERATED
	{
        {0, "|en|NO|fr|NON|de|NEIN"},
        {1, "|en|YES|fr|OUI|de|JA"}
   	}
	HANDLING  WRITE;
} 

/* to display Relation between input current and valve setpoint position */
AXIS axis_current
{
    MIN_VALUE 4;
    MAX_VALUE 20;
    CONSTANT_UNIT "mA";
}
AXIS axis_position
{
    MIN_VALUE 0;
    MAX_VALUE 100;
    CONSTANT_UNIT "%";
}

WAVEFORM waveform_OC_FCT_point
{
    LABEL "Open/Close functionnement points";
    HELP "Define the relation between Input current and position wanted to the valve";
    HANDLING READ;
    EMPHASIS TRUE;
    LINE_TYPE DATA1;
    LINE_COLOR BLUE;
    Y_AXIS axis_position;
    TYPE XY
    {
        X_VALUES{current_1,current_2}
        Y_VALUES{position_1,position_2}
    }
}
WAVEFORM waveform_limit
{
    LABEL "Limit";
    HANDLING READ;
    EMPHASIS TRUE;
    LINE_TYPE DATA1;
    LINE_COLOR FUCHSIA;
    TYPE HORIZONTAL
    {
        Y_VALUES{position_1,position_2}
    }
}
GRAPH graph_OC_FCT_point
{
    LABEL "OC FCT point      [Read Only]";
    HELP "Define the relation between Input current and position wanted to the valve";
    X_AXIS axis_current;
    MEMBERS
    {
        GRAPH_3 , waveform_OC_FCT_point;
        GRAPH_4 , waveform_limit;
    }
}

/* to display Setpoint and Position graphicaly */
/*
SOURCE PV_chart_src
{
    LINE_COLOR RED;
    Y_AXIS axis_position;
    MEMBERS
    {
       POSITION_FOR_CHART , pv_position_variable.DIGITAL_VALUE;
    }
}
SOURCE SV_chart_src
{
    LINE_COLOR BLUE;
    MEMBERS
    {
       SETPOINT_FOR_CHART , sv_setpoint_position.DIGITAL_VALUE;
    }
}
CHART PV_chart
{
    LABEL "SV";
    CYCLE_TIME 1500;
    LENGTH 300000;
    TYPE STRIP;
    MEMBERS
    {
        POSITION_CHART , PV_chart_src;
        SETPOINT_CHART , SV_chart_src;
    }
}
*/




/*******************************************************************************/
/**				    End of Manufacturer specific variables definition   	  **/
/*******************************************************************************/

/*******************************************************************************/
/**				    Manufacturer specific commands definition              **/
/*******************************************************************************/
COMMAND read_endstop_sensor_position
{
	NUMBER    READ_COMMAND_ENDSTOP_POSITION;		// 128;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
			open_endstop_position, close_endstop_position
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
} 

COMMAND read_positioner_state
{
	NUMBER    READ_COMMAND_POSITIONNER_STATE;		// 129;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
			positioner_state
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
}

COMMAND read_control_mode
{
	NUMBER    READ_COMMAND_CONTROL_MODE;		// 130;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
			control_mode
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
} 


COMMAND write_control_mode
{
	NUMBER    WRITE_COMMAND_CONTROL_MODE;		// 131;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			control_mode
		}
		REPLY
		{
			response_code, device_status,
			control_mode
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}

COMMAND read_position_setpoint
{
	NUMBER    READ_COMMAND_POSITION_SETPOINT;		// 132;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
			HART_position_setpoint
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
} 

COMMAND write_position_setpoint
{
	NUMBER    WRITE_COMMAND_POSITION_SETPOINT;		// 133;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			HART_position_setpoint
		}
		REPLY
		{
			response_code, device_status,
			HART_position_setpoint
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}

COMMAND read_gain
{
	NUMBER    READ_COMMAND_GAIN;		// 140;
	OPERATION READ;
	TRANSACTION 
	{
		REQUEST
		{   
		}
		REPLY
		{
			response_code, device_status,
			position_regulator_opening_gain,
            position_regulator_closing_gain
		}
	}
    RESPONSE_CODES
    {
        0,  SUCCESS,    [no_command_specific_errors];
    }
} 

COMMAND write_gain
{
	NUMBER    WRITE_COMMAND_GAIN;		// 141;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			position_regulator_opening_gain,
            position_regulator_closing_gain
		}
		REPLY
		{
			response_code, device_status,
			position_regulator_opening_gain,
            position_regulator_closing_gain
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}

COMMAND read_deadband
{
	NUMBER    READ_COMMAND_DEADBAND;		// 142;
	OPERATION READ;
	TRANSACTION 
	{
		REQUEST
		{
        }
		REPLY
		{
			response_code, device_status,
			positioner_opening_deadband,
            positioner_closing_deadband
		}
	}
    RESPONSE_CODES
    {
        0,  SUCCESS,    [no_command_specific_errors];
    }
} 

COMMAND write_deadband
{
	NUMBER    WRITE_COMMAND_DEADBAND;		// 143;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			positioner_opening_deadband,
            positioner_closing_deadband
		}
		REPLY
		{
			response_code, device_status,
			positioner_opening_deadband,
            positioner_closing_deadband
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}

COMMAND read_positioner_information
{
	NUMBER    READ_COMMAND_POSITIONER_INFO;		// 146;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
			positioner_information.EEX_IA,
			positioner_information.SAFETY_POSITION,
			positioner_information.ANALOG_FEEDBACK,
			positioner_information.END_STOPS
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
} 

COMMAND write_positioner_information
{
	NUMBER    WRITE_COMMAND_POSITIONER_INFO;		// 147;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			positioner_information.EEX_IA,
			positioner_information.SAFETY_POSITION,
			positioner_information.ANALOG_FEEDBACK,
			positioner_information.END_STOPS
		}
		REPLY
		{
			response_code, device_status,
			positioner_information.EEX_IA,
			positioner_information.SAFETY_POSITION,
			positioner_information.ANALOG_FEEDBACK,
			positioner_information.END_STOPS
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}

COMMAND read_actuator_information
{
	NUMBER    READ_COMMAND_ACTUATOR_INFO;		// 148;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
			actuator_information.VENDOR,
			actuator_information.TYP,
			actuator_information.SAFETY_POSITION,
			actuator_information.SIZE
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
} 

COMMAND write_actuator_information
{
	NUMBER    WRITE_COMMAND_ACTUATOR_INFO;		// 149;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			actuator_information.VENDOR,
			actuator_information.TYP,
			actuator_information.SAFETY_POSITION,
			actuator_information.SIZE
		}
		REPLY
		{
			response_code, device_status,
			actuator_information.VENDOR,
			actuator_information.TYP,
			actuator_information.SAFETY_POSITION,
			actuator_information.SIZE
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}

COMMAND read_valve_type
{
	NUMBER    READ_COMMAND_VALVE_TYPE;		// 150;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
			valve_type.VENDOR,
			valve_type.TYPE_,
			valve_type.SIZE,
            valve_type.CLOSE_DIR

		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
} 

COMMAND write_valve_type
{
	NUMBER    WRITE_COMMAND_VALVE_TYPE;		// 151;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			valve_type.VENDOR,
			valve_type.TYPE_,
			valve_type.SIZE,
            valve_type.CLOSE_DIR
		}
		REPLY
		{
			response_code, device_status,
			valve_type.VENDOR,
			valve_type.TYPE_,
			valve_type.SIZE,
            valve_type.CLOSE_DIR
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}

COMMAND read_total_runtime
{
	NUMBER    READ_COMMAND_TOTAL_RT;		// 155;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
            run_time.DAYS,
            //run_time.DAYS,
            //run_time.DAYS
            run_time.HOURS_,
           run_time.MINUTES_
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
} 
/*
COMMAND read_rst_stats
{
	NUMBER    READ_COMMAND_RST_STAT;		// 156;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
            0
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
} 
*/
COMMAND read_runtime_since_rst_stat
{
	NUMBER    READ_COMMAND_RT_SINCE_RST;		// 157;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
            run_time_since_last_stat_rst.DAYS,
            //run_time_since_last_stat_rst.DAYS,
            //run_time_since_last_stat_rst.DAYS
            run_time_since_last_stat_rst.HOURS_,
            run_time_since_last_stat_rst.MINUTES_
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
} 

COMMAND read_number_of_operations
{
	NUMBER    READ_COMMAND_NB_OPERATIONS;		// 158;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
            num_of_operations
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
} 

COMMAND read_oc_fct_points
{
	NUMBER    READ_COMMAND_OC_FCT_POINTS;		// 161;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
			position_1,
            current_1,
            position_2,
            current_2
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
}
COMMAND write_oc_fct_points
{
	NUMBER    WRITE_COMMAND_OC_FCT_POINTS;		// 162;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
            position_1,
            current_1,
            position_2,
            current_2
		}
		REPLY
		{
			response_code, device_status,
			position_1,
            current_1,
            position_2,
            current_2
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
}

COMMAND read_protect_mode
{
	NUMBER    READ_COMMAND_PROTECT_MODE;		// 163;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			response_code, device_status,
			protect_mode
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors];
	}
} 

COMMAND write_protect_mode
{
	NUMBER    WRITE_COMMAND_PROTECT_MODE;		// 164;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{   
            protect_password,
			protect_mode            
		}
		REPLY
		{
			response_code, device_status,
			protect_password,
            protect_mode            
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}

COMMAND write_etalon_4mA
{
	NUMBER    WRITE_COMMAND_ETALON_INPUT_4mACURRENT;		// 165;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			etalonage_4_20mA._4mA
		}
		REPLY
		{
			response_code, device_status,
			etalonage_4_20mA._4mA
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}

COMMAND write_etalon_20mA
{
	NUMBER    WRITE_COMMAND_ETALON_INPUT_20mACURRENT;		// 166;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
            etalonage_4_20mA._20mA
		}
		REPLY
		{
			response_code, device_status,
            etalonage_4_20mA._20mA
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}
COMMAND write_etalon_out_4mA
{
	NUMBER    WRITE_COMMAND_ETALON_OUTPUT_4_20mACURRENT;		// 167;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			etalonage_out_4mA,
            etalonage_out_20mA
		}
		REPLY
		{
			response_code, device_status,
			etalonage_out_4mA,
            etalonage_out_20mA
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}


COMMAND write_gestion_etalon_output_current
{
	NUMBER    WRITE_COMMAND_GESTION_ETALON_OUTPUT_CURRENT;		// 168;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			gestion_etalon_sortie_courant
		}
		REPLY
		{
			response_code, device_status,
			gestion_etalon_sortie_courant
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}

COMMAND write_gestion_autocalibration
{
	NUMBER    WRITE_COMMAND_GESTION_AUTOCALIBRATION;		// 169;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			gestion_autocalibration
		}
		REPLY
		{
			response_code, device_status,
			gestion_autocalibration
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}

COMMAND read_state_of_cmd_169_and_170
{
	NUMBER    READ_COMMAND_STATE_OF_CMD_169_AND_170;		// 171;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			response_code, device_status,
            gestion_autocalibration,
            sauvegarde_cmd151
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}

COMMAND read_value_etalon_output
{
	NUMBER    READ_COMMAND_VALUE_ETALON_OUTPUT;		// 172;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			response_code, device_status,
            etalonage_out_4mA,
            etalonage_out_20mA,
            gestion_etalon_sortie_courant
		}
	}
	RESPONSE_CODES
	{
		0,  SUCCESS,    [no_command_specific_errors]; 
	}
}


/*******************************************************************************/
/**				    End of Manufacturer specific commands definition    	  **/
/*******************************************************************************/

/*********************************************************************/
/**				    Methods definition 					            **/
/*********************************************************************/
METHOD  autocalibration_method
{
	LABEL	"|en|3-2-1 Autocalibration|fr|3-2-1 Autocalibration|de|3-2-1 Autocalibration";
	HELP	"|en|To start the autocalibration procedure.\nCAUTION: Communication is disable during autocalibration.\nWhen autocalibration is ended, communication is enable|fr|Pour lancer la procdure d'autocalibration.\nAttention :  la communication HART est interrompu pendant l'autocalibration.\nQuand l'autocalibration est fini, la communication est autorise|de|To start the autocalibration procedure.\nCAUTION: Communication is disable during autocalibration.\nWhen autocalibration is ended, communication is enable";
 	DEFINITION
    {
        GET_DEV_VAR_VALUE("|en|CAUTION: Communication is disable during autocalibration.\n\nWhen autocalibration is ended, communication is enable\n\nStart Autocalibraiton ?|fr|Attention :  la communication HART est interrompu pendant l'autocalibration.\n\nQuand l'autocalibration est fini, la communication est autorise\n\nDmarrer l'autocalibration ?|de|CAUTION: Communication is disable during autocalibration.\n\nWhen autocalibration is ended, communication is enable\n\nStart Autocalibraiton ?", Lance_autocalib);
        assign_var(gestion_autocalibration,Lance_autocalib);
        send_command(WRITE_COMMAND_GESTION_AUTOCALIBRATION);
    }
}

METHOD  write_actuator_info_method
{
	LABEL	"|en|4-3-5 Write actuator info|fr|4-3-5 Ecrire info actionneur|de|4-3-5 Write actuator info";
	HELP	"|en|To write all actuator informations|fr|Pour crire toutes les infos de l'actionneur|de|To write all actuator informations";
 	DEFINITION
   {
        GET_DEV_VAR_VALUE("|en|Write vendor name|fr|Ecrire le nom du fabricant|de|Write vendor name", actuator_information.VENDOR);
        GET_DEV_VAR_VALUE("|en|Write actuator type|fr|Ecrire le type d'actionneur|de|Write actuator type", actuator_information.TYP);
        GET_DEV_VAR_VALUE("|en|Write actuator safety position|fr|Ecrire la position de scurit de l'actionneur|de|Write actuator safety position",actuator_info_safety_position);        
        GET_DEV_VAR_VALUE("|en|Write actuator size|fr|Ecrire la taille de l'actionneur|de|Write actuator size", actuator_information.SIZE);
        send_command(WRITE_COMMAND_ACTUATOR_INFO);
    }
}
METHOD  write_valve_info_method
{
	LABEL	"|en|4-4-4 Write valve info|fr|4-4-4 Ecrire info robinet|de|4-4-4 Write valve info";
	HELP	"|en|To write all valve informations|fr|Pour crire toutes les infos du robinet|de|To write all valve informations";
 	DEFINITION
   {
        GET_DEV_VAR_VALUE("|en|Write vendor Name|fr|Ecrire le nom du fabricant|de|Write vendor Name", valve_type.VENDOR);
        GET_DEV_VAR_VALUE("|en|Write valve type|fr|Ecrire le type du robinet|de|Write valve type", valve_type.TYPE_);
        GET_DEV_VAR_VALUE("|en|Write valve size|fr|Ecrire la taille du robinet|de|Write valve size",valve_type.SIZE); 
        send_command(WRITE_COMMAND_VALVE_TYPE);
    }
}
METHOD  etalon_4_20mA_method
{
	LABEL	"|en|3-6-1-1 Start ana. in calib.|fr|3-6-1-1 Dmarre calib entre ana|de|3-6-1-1 Start ana.in calib.";
	HELP	"|en|Click to start the calibratiobn of the analog input|fr|Click pour lancer la calibration de l'entre analogique|de|Click to start the calibratiobn of the analog input";
 	DEFINITION
    {        
        GET_DEV_VAR_VALUE("|en|WARNING! Put 4mA in the input current loop|fr|ATTENTION! Mettre 4mA sur l'entre courant|de|WARNING! Put 4mA in the input current loop", etalonage_4_20mA._4mA); 
        send_command(WRITE_COMMAND_ETALON_INPUT_4mACURRENT);
        GET_DEV_VAR_VALUE("|en|WARNING! Put 20mA in the input current loop|fr|ATTENTION! Mettre 20mA sur l'entre courant|de|WARNING! Put 20mA in the input current loop",etalonage_4_20mA._20mA);        
        send_command(WRITE_COMMAND_ETALON_INPUT_20mACURRENT);
    }
}
METHOD  etalon_sortie_4_20mA_method
{
	LABEL	"|en|3-6-2-4 Start ana. out calib.|fr|3-6-2-4 Dmarre calib sortie ana|de|3-6-2-4 Start ana. out calib.";
	HELP	"|en|Click to start the calibration of the analog output|fr|Click pour lancer la calibration de la sortie analogique|de|Click to start the calibratiobn of the analog output";
 	DEFINITION
    {    
        assign_int(gestion_etalon_sortie_courant,2);
        send_command(WRITE_COMMAND_GESTION_ETALON_OUTPUT_CURRENT);
        GET_DEV_VAR_VALUE("|en|WARNING! Low level value : write the real output current value [in mA]|fr|ATTENTION! Niveau bas : crire la valeur relle de la sortie analogique [en mA]|de|WARNING! Low level value : write the real output current value [in mA]", etalonage_out_4mA); 

        assign_int(gestion_etalon_sortie_courant,3);
        send_command(WRITE_COMMAND_GESTION_ETALON_OUTPUT_CURRENT);
        GET_DEV_VAR_VALUE("|en|WARNING! High level value : write the real output current value [in mA]|fr|ATTENTION! Niveau haut : crire la valeur relle de la sortie analogique [en mA]|de|WARNING! High level value : write the real output current value [in mA]",etalonage_out_20mA);        

        assign_int(gestion_etalon_sortie_courant,0);
        send_command(WRITE_COMMAND_GESTION_ETALON_OUTPUT_CURRENT);
        send_command(WRITE_COMMAND_ETALON_OUTPUT_4_20mACURRENT);
    }
}

/*********************************************************************/
/**				    CHART definition 					            **/
/*********************************************************************/



/*********************************************************************/
/**				    Menus definition 					            **/
/*********************************************************************/
MENU root_menu
{
    LABEL "|en|KSB Hart Positioner|fr|Positionneur HART KSB|de|KSB Hart Positioner";
    STYLE WINDOW;
    ITEMS
    {
        operation_menu,
        diag_service,
        settings_menu,
        Info_menu
    }
}

MENU operation_menu
{
    LABEL "|en|1 Operation|fr|1 Opration|de|1 Operation";
    STYLE PAGE;
    ITEMS
    {
        system_menu
        endstop_position_menu
        //HART_setpoint_menu      
    }
}

MENU system_menu
{
    LABEL "|en|1-1 System|fr|1-1 Systme|de|1-1 System";
    HELP "|en|Operating data of the system|fr|Donnes de fonctionnement du systme|de|Operating data of the system";
    STYLE PAGE;
    ITEMS
    {   
        PV.DAQ.ANALOG_VALUE (DISPLAY_VALUE),
        pv_position_variable.DIGITAL_VALUE(DISPLAY_VALUE) ,
        sv_setpoint_position.DIGITAL_VALUE(DISPLAY_VALUE) ,
        tv_system_deviation.DIGITAL_VALUE(DISPLAY_VALUE) ,
        qv_copy_position.DIGITAL_VALUE(DISPLAY_VALUE)// ,
        //control_mode(DISPLAY_VALUE)
        //control_mode
        /* to display Setpoint and Position graphicaly */
//        PV_chart
    }
}

MENU endstop_position_menu
{
		LABEL "|en|1-2 Endstop sensors|fr|1-2 Detecteurs fin de course|de|1-2 Endstop sensors";
        HELP "|en|Endstop position sensors values|fr|Etat detecteur fin de course|de|Endstop position sensors values";
        ITEMS
		{
            open_endstop_position(DISPLAY_VALUE),
            close_endstop_position(DISPLAY_VALUE)
		}
}

MENU HART_setpoint_menu
{
		LABEL "|en|3-1-2 HART setpoint|fr|1-3 Consigne HART|de|1-3 HART setpoint";
        HELP "|en|Setpoint when the positioner is controlled by HART|fr|Consigne lorsque le positionneur est control par HART|de|Setpoint when the positioner is controlled by HART";
        ITEMS
		{
            HART_position_setpoint
		}
}



MENU settings_menu
{
    LABEL "|en|3 Settings|fr|3 Configuration|de|3 Settings";
    HELP "|en|Settings|fr|Configuration|de|Settings";
    STYLE PAGE;
    ITEMS
    {
        control_mode_menu,
        Regulator_menu,
        oc_fct_points,
        close_dir_menu,
        device_safety_position_menu,
        gauge_menu,COLUMNBREAK,
        graph_OC_FCT_point
    }
}

MENU control_mode_menu
{
    LABEL "|en|3-1 Control mode|fr|3-1 Mode de commande|de|3-1 Control mode";
    HELP "|en|Control mode|fr|Mode de commande|de|Control mode";
    STYLE PAGE;
    ITEMS
    {
        control_mode,
        HART_position_setpoint
     }
}


MENU Regulator_menu
{
		LABEL "|en|3-2 Calibration|fr|3-2 Calibration|de|3-2 Calibration";
        HELP "|en|Calibration|fr|Calibration|de|Calibration";
        STYLE DIALOG;
		ITEMS
		{           
            //gestion_autocalibration(DISPLAY_VALUE),
            autocalibration_method,
            positioner_state(DISPLAY_VALUE),
            gain_menu,
            dead_band_menu
		}
}

MENU gain_menu
{
		LABEL "|en|3-2-3 Regulator gain|fr|3-2-3 Gain rgulation|de|3-2-3 Regulator gain";
        HELP "|en|Gain of the regulator algotithm|fr|Gain de l'algorithme de rgulation|de|Gain of the regulator algotithm";
//        STYLE PAGE;
		ITEMS
		{
           position_regulator_opening_gain(DISPLAY_VALUE),
           position_regulator_closing_gain(DISPLAY_VALUE)
		}
}

MENU dead_band_menu
{
		LABEL "|en|3-2-4 Regulator dead band|fr|3-2-4 Bande morte rgulateur|de|3-2-4 Regulator dead band";
        HELP "|en|Dead band of the positioner|fr|Bande morte du positionneur|de|Dead band of the positioner";
//        STYLE PAGE;
		ITEMS
		{
           positioner_opening_deadband(DISPLAY_VALUE),
           positioner_closing_deadband(DISPLAY_VALUE)
		}
}

MENU oc_fct_points
{
		LABEL "|en|3-3 O/C fct point|fr|3-3 O/F point fct|de|3-3 O/C fct point";
        HELP "|en|Define the min. and the max. of the input current and the setpoints associated with these current levels|fr|Dfini le min et le max de l'entre courant et la consigne associe avec ce niveau de courant|de|Define the min. and the max. of the input current and the setpoints associated with these current levels";
		ITEMS
		{
            current_1(DISPLAY_VALUE),
            position_1(DISPLAY_VALUE),  
            current_2(DISPLAY_VALUE),
            position_2(DISPLAY_VALUE)
		}
}
MENU close_dir_menu
{
		LABEL "|en|3-4 Closing direction|fr|3-4 Sens fermeture|de|3-4 Closing direction";
        HELP "|en|Define if the valve is clockwise or counter clockwise closed|fr|Dfinie si le robinet se ferme dans le sens horaire ou anti horaire|de|Define if the valve is clockwise or counter clockwise closed";
		ITEMS
		{
           valve_type.CLOSE_DIR(DISPLAY_VALUE)
		}
}
MENU device_safety_position_menu
{
		LABEL "|en|3-5 Safety position|fr|3-5 Position de replie|de|3-5 Safety position";
        HELP "|en|Device safety position|fr|Position de scurit hors alimentation lectrique|de|Device safety position";
        ITEMS
		{
            positioner_information.SAFETY_POSITION(DISPLAY_VALUE)
		}
}


MENU gauge_menu
{
		LABEL "|en|3-6 Ana. in/out calib.|fr|3-6 Calib entre/sortie ana|de|3-6 Ana. in/out calib.";
        HELP "|en|Calibration of the analog input and output of the device|fr|Calibration des entres et sorties du positionneur|de|Calibration of the analog input and output of the device";
        STYLE DIALOG;
        ITEMS
		{
            gauge_input_current_loop_menu,
            gauge_output_current_loop_menu
   		}
}
MENU gauge_input_current_loop_menu
{
		LABEL "|en|3-6-1 ana. input calib.|fr|3-6-1 calib entre ana|de|3-6-1 ana. input calib.";
        HELP "|en|Calibration of the analog input|fr|Calibration de l'entre analogique|de|Calibration of the analog input";
        ITEMS
		{
            etalon_4_20mA_method
   		}
}
MENU gauge_output_current_loop_menu
{
		LABEL "|en|3-6-2 ana. output calib.|fr|3-6-2 calib sortie ana|de|3-6-2 ana. output calib.";
        HELP "|en|Calibration of the analog output|fr|Calibration de la sortie analogique|de|Calibration of the analog output"; 
        ITEMS
		{                
            etalonage_out_4mA(DISPLAY_VALUE),  
            etalonage_out_20mA(DISPLAY_VALUE),
            gestion_etalon_sortie_courant,
            etalon_sortie_4_20mA_method
		}
} 

MENU diag_service
{
        LABEL "|en|2 Diagnosis|fr|2 Diagnostique|de|2 Diagnosis";
        HELP "|en|Control and diagnose|fr|Controle et diagnistique|de|Control and diagnose";
        STYLE PAGE;
        ITEMS
        {
            num_of_operation_menu,
            Run_time_menu
        }
}

MENU num_of_operation_menu
{
        LABEL "|en|2-1 Number of operations|fr|2-1 Nombre d'opration|de|2-1 Number of operations";
        HELP "|en|Number of operations (one operation corresponds to 180 valve movement)|fr|Nombre d'opration (une opration correspond  un dplacement du robinet de 180)|de|Number of operations (one operation corresponds to 180 valve movement)";
        STYLE PAGE;
        ITEMS
        {
            num_of_operations(DISPLAY_VALUE)
        }
}


MENU Run_time_menu
{
		LABEL "|en|2-2 Run Time|fr|2-2 Temps fonctionnement|de|2-2 Run Time";
        HELP "|en|Run time|fr|Temps de fonctionnement|de|Run time";
        STYLE GROUP;
		ITEMS
		{
           Total_runtime_menu,
           Runtime_since_stat_rst
		}
}

MENU Total_runtime_menu
{
		LABEL "|en|2-2-1 Total run time|fr|2-2-1 Temps fct total|de|2-2-1 Total run time";
        HELP "|en|Run time since the commissionning of the product|fr|Temps coul depuis la mise en marche du produit|de|Run time since the commissionning of the product";
        STYLE GROUP;
		ITEMS
		{
           run_time.DAYS(DISPLAY_VALUE),
           //run_time.DAYS(DISPLAY_VALUE),
           //run_time.DAYS(DISPLAY_VALUE)
           run_time.HOURS_(DISPLAY_VALUE),
           run_time.MINUTES_(DISPLAY_VALUE)
		}
}

MENU Runtime_since_stat_rst
{
		LABEL "|en|2-2-2 Run time since reset|fr|2-2-2 Temps fct depuis reset|de|2-2-2 Run time since reset";
        HELP "|en|Run time since the last statistics reset|fr|Temps coul depuis le dernier Reset des statistiques|de|Run time since the last statistics reset";
        STYLE GROUP;
		ITEMS
		{
           run_time_since_last_stat_rst.DAYS(DISPLAY_VALUE),
           //run_time_since_last_stat_rst.DAYS(DISPLAY_VALUE),
           //run_time_since_last_stat_rst.DAYS(DISPLAY_VALUE)
           run_time_since_last_stat_rst.HOURS_(DISPLAY_VALUE),
           run_time_since_last_stat_rst.MINUTES_(DISPLAY_VALUE)
		}
}

MENU Info_menu
{
		LABEL "|en|4 Info|fr|4 Info|de|4 Info";
        HELP "|en|Informations|fr|Informations|de|Informations";
        STYLE PAGE;
        ITEMS
		{   
            device_info,COLUMNBREAK,            
            positioner_info_menu,
            actuator_info_menu,COLUMNBREAK,
            valve_type_menu,            
            hart_menu
	    }
}

MENU device_info
{
    LABEL "|en|4-1 Device|fr|4-1 Appareil|de|4-1 Device";
    HELP "|en|Device informations|fr|Informations appareil|de|Device informations";
    STYLE GROUP;
    ITEMS
    {
            manufacturer_id (DISPLAY_VALUE),
            device_type (DISPLAY_VALUE),
            //device_id (DISPLAY_VALUE),
            tag (DISPLAY_VALUE),                        
            descriptor (DISPLAY_VALUE),                 
            longTag(DISPLAY_VALUE),                     
            message (DISPLAY_VALUE),                    
            final_assembly_number (DISPLAY_VALUE),                                               
            date_menu,
            device_revisions_menu                           
    }
}
MENU date_menu
{
    LABEL "|en|4-1-8 Date|fr|4-1-8 Date|de|4-1-8 Date";
    HELP "|en|Device assembly date|fr|Date d'assemblage de l'appareil|de|Device assembly date";
    STYLE GROUP;
    ITEMS
    {
        date (DISPLAY_VALUE)  
    }
}
MENU device_revisions_menu
{
    LABEL "|en|4-1-9 Revision|fr|4-1-9 Version|de|4-1-9 Revision";
    HELP "|en|Device revision informations|fr|Informations version appareil|de|Device revision informations";
    STYLE GROUP;
    ITEMS
    {
        universal_revision (DISPLAY_VALUE),     
        transmitter_revision (DISPLAY_VALUE),   
        software_revision (DISPLAY_VALUE),
        hardware_revision (DISPLAY_VALUE)
     }
}
MENU positioner_info_menu
{
		LABEL "|en|4-2 Positioner|fr|4-2 Positionneur|de|4-2 Positioner";
        HELP "|en|Positioner informations|fr|Informations positionneur|de|Positioner informations";
        STYLE GROUP;
		ITEMS
		{
           positioner_information.EEX_IA(DISPLAY_VALUE),
		   positioner_information.ANALOG_FEEDBACK(DISPLAY_VALUE),
		   positioner_information.END_STOPS(DISPLAY_VALUE)
		}
}
MENU actuator_info_menu
{
		LABEL "|en|4-3 Actuator|fr|4-3 Actionneur|de|4-3 Actuator";
        HELP "|en|Actuator informations|fr|Informations actionneur|de|Actuator informations";
        STYLE GROUP;
		ITEMS
		{
           actuator_information.VENDOR(DISPLAY_VALUE),
           actuator_information.TYP(DISPLAY_VALUE),
           actuator_information.SAFETY_POSITION(DISPLAY_VALUE),
           actuator_information.SIZE(DISPLAY_VALUE),
           write_actuator_info_method
		}
}
MENU valve_type_menu
{
		LABEL "|en|4-4 Valve|fr|4-4 Robinet|de|4-4 Valve";
        HELP "|en|Valve informations|fr|Informations robinet|de|Valve informations";
        STYLE GROUP;
		ITEMS
		{
           valve_type.VENDOR(DISPLAY_VALUE),
           valve_type.TYPE_(DISPLAY_VALUE),
           valve_type.SIZE(DISPLAY_VALUE)
           write_valve_info_method
		}
}
MENU hart_menu
{
        LABEL "|en|4-5 HART|fr|4-5 HART|de|4-5 HART";
        HELP "|en|HART informations|fr|Informations HART|de|HART informations";
        STYLE PAGE;
        ITEMS
        {
            polling_address (DISPLAY_VALUE)
        }
}

/* unused */

/*
SOURCE PV_chart_src
{
    LINE_COLOR GREEN;
    Y_AXIS axis_position;
    MEMBERS
    {
       POSITION_FOR_CHART , pv_position_variable.DIGITAL_VALUE;
    }
}

SOURCE SV_chart_src
{
    LINE_COLOR BLUE;
    MEMBERS
    {
       SETPOINT_FOR_CHART , sv_setpoint_position.DIGITAL_VALUE;
    }
}
CHART SV_chart
{
    LABEL "SV";
    HEIGHT XX_SMALL;
    WIDTH XX_SMALL;
    TYPE HORIZONTAL_BAR;
    MEMBERS
    {
        CHART_2 , SV_chart_src;
    }
}


SOURCE TV_chart_src
{
    LINE_COLOR FUCHSIA;
    MEMBERS
    {
       DEVIATION_FOR_CHART , tv_system_deviation.DIGITAL_VALUE;
    }
}
CHART TV_chart
{
    LABEL "TV";
    HEIGHT XX_SMALL;
    WIDTH XX_SMALL;
    TYPE HORIZONTAL_BAR;
    MEMBERS
    {
        CHART_3 , TV_chart_src;
    }
}


SOURCE QV_chart_src
{
    LINE_COLOR ORANGE;
    MEMBERS
    {
       COPY_FOR_CHART , qv_copy_position.DIGITAL_VALUE;
    }
}
CHART QV_chart
{
    LABEL "QV";
    HEIGHT XX_SMALL;
    WIDTH XX_SMALL;
    TYPE HORIZONTAL_BAR;
    MEMBERS
    {
        CHART_4 , QV_chart_src;
    }
}
*/

/*
MENU process_variables
{
    LABEL "Detailed info of Dynamic Values";
    STYLE DIALOG;
    ITEMS
    {   
        menu_in_current,
        menu_position,                           
        menu_setpoint,                           
        menu_deviation,
        menu_output_current
    }
}
MENU menu_position
{
    LABEL "Position";
    STYLE PAGE;
    ITEMS
    {
        pv_position_variable.DIGITAL_VALUE (DISPLAY_VALUE),            
 //       PV.RANGING.PERCENT_RANGE (DISPLAY_VALUE),           
        menu_sensor_info (REVIEW)                           
    }
}

MENU menu_sensor_info
{
    LABEL "Information";
    STYLE GROUP;
    ITEMS
    {   
//        strip_position,
        //"PV with Status :",     //cmd 9
        pv_position_variable.CLASSIFICATION (DISPLAY_VALUE),
        pv_position_variable.DIGITAL_UNITS (DISPLAY_VALUE),
        pv_position_variable.DIGITAL_VALUE (DISPLAY_VALUE),
        //"PV Status :",          // Device Variable Status
        pv_position_variable.DATA_QUALITY (DISPLAY_VALUE),  // Process Data Status            
        pv_position_variable.LIMIT_STATUS (DISPLAY_VALUE),  // Limit Status
        pv_position_variable.DEVICE_FAMILY_STATUS (DISPLAY_VALUE),  // Device Family Status
        //"Device Information :", // cmd 15
        pv_position_variable.LOWER_SENSOR_LIMIT (DISPLAY_VALUE),      
        pv_position_variable.UPPER_SENSOR_LIMIT (DISPLAY_VALUE)      
//        pv_position_variable.MINIMUM_SPAN (DISPLAY_VALUE),            
//        pv_position_variable.DAMPING_VALUE (DISPLAY_VALUE),           
//        pv_position_variable.SENSOR_SERIAL_NUMBER (DISPLAY_VALUE)     
    }
}

MENU menu_setpoint
{
    LABEL "Setpoint";
    STYLE PAGE;
    ITEMS
    {
        sv_setpoint_position.DIGITAL_VALUE (DISPLAY_VALUE),           
        menu_sensor2_info (REVIEW)                          
    }
}

MENU menu_sensor2_info
{
    LABEL "Information";
    STYLE GROUP;
    ITEMS
    {
        //"SV with Status :",     //cmd 9
        sv_setpoint_position.CLASSIFICATION (DISPLAY_VALUE),                
        sv_setpoint_position.DIGITAL_UNITS (DISPLAY_VALUE),     
        sv_setpoint_position.DIGITAL_VALUE (DISPLAY_VALUE),
        //"SV Status :",          // Device Variable Status
        sv_setpoint_position.DATA_QUALITY (DISPLAY_VALUE),      // Process Data Status            
        sv_setpoint_position.LIMIT_STATUS (DISPLAY_VALUE),      // Limit Status            
        sv_setpoint_position.DEVICE_FAMILY_STATUS (DISPLAY_VALUE)   // Device Family Status
    }
}
 
MENU menu_deviation
{
    LABEL "Deviation";
    STYLE PAGE;
    ITEMS
    {
        tv_system_deviation.DIGITAL_VALUE (DISPLAY_VALUE),             
        menu_sensor3_info (REVIEW)                          
    }
}

MENU menu_sensor3_info
{
    LABEL "Information";
    STYLE GROUP;
    ITEMS
    {
        //"TV with Status :",     //cmd 9
        tv_system_deviation.CLASSIFICATION (DISPLAY_VALUE), 
        tv_system_deviation.DIGITAL_UNITS (DISPLAY_VALUE),
        tv_system_deviation.DIGITAL_VALUE (DISPLAY_VALUE),
        //"TV Status :",          // Device Variable Status
        tv_system_deviation.DATA_QUALITY (DISPLAY_VALUE),   // Process Data Status                        
        tv_system_deviation.LIMIT_STATUS (DISPLAY_VALUE),   // Limit Status            
        tv_system_deviation.DEVICE_FAMILY_STATUS (DISPLAY_VALUE)    // Device Family Status
    }
}

MENU menu_output_current
{
    LABEL "Output current";
    STYLE PAGE;
    ITEMS
    {
        qv_copy_position.DIGITAL_VALUE (DISPLAY_VALUE),             
        menu_sensor4_info (REVIEW)                          
    }
}

MENU menu_sensor4_info
{
    LABEL "Information";
    STYLE GROUP;
    ITEMS
    {
        //"QV with Status :",     //cmd 9
        qv_copy_position.CLASSIFICATION (DISPLAY_VALUE), 
        qv_copy_position.DIGITAL_UNITS (DISPLAY_VALUE),
        qv_copy_position.DIGITAL_VALUE (DISPLAY_VALUE),
        //"QV Status :",          // Device Variable Status
        qv_copy_position.DATA_QUALITY (DISPLAY_VALUE),  // Process Data Status                                    
        qv_copy_position.LIMIT_STATUS (DISPLAY_VALUE),  // Limit Status            
        qv_copy_position.DEVICE_FAMILY_STATUS (DISPLAY_VALUE)   // Device Family Status
    }
}


MENU menu_in_current
{
    LABEL "In current";
    STYLE PAGE;
    ITEMS
    {
        PV.DAQ.ANALOG_VALUE (DISPLAY_VALUE)
    }
}

MENU control_mode_menu
{
		LABEL "Control mode";
		ITEMS
		{
           control_mode(DISPLAY_VALUE)
//           refresh_data_controlmode
		}
}

MENU test_device 
{
    LABEL [test_device];
    ITEMS
    {
        status_display_menu
//        perform_self_device_test
    }
}


MENU status_display_menu
{
    LABEL [status];
    ITEMS
    {
        device_specific_status_0 (DISPLAY_VALUE),
        device_specific_status_1 (DISPLAY_VALUE),
        device_specific_status_2 (DISPLAY_VALUE),
        device_specific_status_3 (DISPLAY_VALUE),
        device_specific_status_4 (DISPLAY_VALUE),
        device_specific_status_5 (DISPLAY_VALUE),
        operatingMode (DISPLAY_VALUE),
        analog_channel_saturated1 (DISPLAY_VALUE),
        analog_channel_saturated2 (DISPLAY_VALUE),
        analog_channel_saturated3 (DISPLAY_VALUE),
        analog_channel_fixed1 (DISPLAY_VALUE),
        analog_channel_fixed2 (DISPLAY_VALUE),
        analog_channel_fixed3 (DISPLAY_VALUE),
        device_specific_status_14 (DISPLAY_VALUE),
        device_specific_status_15 (DISPLAY_VALUE),
        device_specific_status_16 (DISPLAY_VALUE),
        device_specific_status_17 (DISPLAY_VALUE),
        device_specific_status_18 (DISPLAY_VALUE),
        device_specific_status_19 (DISPLAY_VALUE),
        device_specific_status_20 (DISPLAY_VALUE),
        device_specific_status_21 (DISPLAY_VALUE),
        device_specific_status_22 (DISPLAY_VALUE),
        device_specific_status_23 (DISPLAY_VALUE),
        device_specific_status_24 (DISPLAY_VALUE)
    }
}

MENU output_condition
{
    LABEL [output_condition];
    ITEMS
    {
        analog_output_menu
   }
}

MENU analog_output_menu
{
        LABEL [analog_output];
        ITEMS
        {
            qv_copy_position.DIGITAL_VALUE (DISPLAY_VALUE),   
            qv_copy_position.DIGITAL_UNITS (DISPLAY_VALUE),   
            loop_current_mode  (DISPLAY_VALUE)
//           write_loop_current_mode
        }
}

MENU signal_condition
{
    LABEL [signal_condition];
    ITEMS
    {
        PV.DAQ.ALARM_CODE (DISPLAY_VALUE, READ_ONLY),
        PV.RANGING.TRANSFER_FUNCTION (DISPLAY_VALUE),
        PV.RANGING.RANGE_UNITS (DISPLAY_VALUE), 
        PV.RANGING.LOWER_RANGE_VALUE (DISPLAY_VALUE, READ_ONLY),       
        PV.RANGING.UPPER_RANGE_VALUE (DISPLAY_VALUE, READ_ONLY),       
        PV.DEVICE_VARIABLE.DAMPING_VALUE (DISPLAY_VALUE)
        write_protect (DISPLAY_VALUE), 
        private_label_distributor (DISPLAY_VALUE),
        PV.DAQ.ANALOG_CHANNEL_FLAGS (DISPLAY_VALUE)
    }
}

MENU unused
{
    LABEL "unused";
    ITEMS
    {
        request_preambles (DISPLAY_VALUE),
        physical_signaling_code (DISPLAY_VALUE),
        device_flags (DISPLAY_VALUE),
        device_id (DISPLAY_VALUE),
        response_preambles (DISPLAY_VALUE),
        max_num_device_variables (DISPLAY_VALUE),
        config_change_counter (DISPLAY_VALUE),
        extended_fld_device_status (DISPLAY_VALUE),
        polling_address (DISPLAY_VALUE, READ_ONLY),
        loop_current_mode (DISPLAY_VALUE, READ_ONLY),
        write_protect (DISPLAY_VALUE, READ_ONLY)
    }
}
*/
